% New PRM planner

 clear all;
figure(1)
hold off
plot3(0,0,0,'o')
hold on

% Makes some obstacles
[Obstacles oT oRot oTrans obsN] = makeObstaclesTest(1);

% Makes the robot in final position
% finalPos = [-5 -3 -4]';
% thetaFinal = [pi/3 -pi/5 -pi/7 pi/4 pi/4 pi/6];
% [Manip, Man, ffT, lfT, lfRot, lfTrans, DenHaf, LinLimits, JALimits] = makeRobot(finalPos, thetaFinal);
%    
% Makes the  robot in its initial position  
    %%%%%% Initial pose %%%%%%%
linValues = [5 -2 -0.5]';     
thetaStart = [pi/3 pi/6 -pi/6 pi/8 -pi/4 pi/6]';
[Manip, Man, fT, lT, lRot, lTrans, DH, LinLimits, JALimits] = makeRobot(linValues, thetaStart);

% theta = [DH(5,1) DH(6,1) DH(7,1) DH(8,1) DH(9,1) DH(10,1)]';

%% Probabilisitc road map
w = [0 0.5 0.5 0.5 2 2 2 2 2 2];
step = 1;

for i=1:20
%     clear Samples
%     clear Components

 [coverage, TotalCoverage, sumQueriesConnection, TestResultConnection, TotalConnectionTime, TotalPathSearchTime, sampleTime ] = makeGaussianSamples_Nearest_k(75, LinLimits, JALimits, 30/180*pi,w, step, Obstacles, oRot, oTrans);
 
 FinalCoverage(i,:) = coverage;
 FinalTotalCoverage(i,:) = TotalCoverage;
 FinalSumQueriesConnection(i,:) = sumQueriesConnection;
 FinalTestResultConnection(:,:,i) =  TestResultConnection;
 FinalTotalConnectionTime(:,:,:,i) = TotalConnectionTime;
 FinaleTotalPathSearchTime(:,:,:,i)= TotalPathSearchTime;
 FinaleSampleTime(i,:) = sampleTime ;
 
end

%  [Samples Components] = makeGaussianSamples_Nearest_k(75, LinLimits, JALimits, 30/180*pi,w, step, Obstacles, oRot, oTrans);
 
% %% Test the probabilistic road map
% 
% [testConfigCovered, TestQueryConnection ] = PRM_4(Components, Samples);
% % Storing the covering
% Cover(:,i) = testConfigCovered;
% % Storing the connection
% TestResultConnection(:,:,i) = TestQueryConnection;
% sumColums = sum(TestQueryCovered);
% sumQueriesCovered(i) = sum(sumColums);

% end

% numberOfTimesCovered = sum(FinalCoverage,2);


