% Binary Collision Test between two configurations

function [inter type] = advanced_binCollisionCheckABB(Config,maxStep,maxAngle, linksN, obsN, Obstacles, oRot, oTrans)
inter = false;
intervalLin =100;
intervalAngle=100;
teller = 1;
type = 1;

% maxStep;
% maxAngle;
while intervalLin>maxStep || intervalAngle>maxAngle

    clear newConfig
    newConfig = Config(1:linksN,1);
    [not n] = size(Config);
    
    for i =1:n-1

        mid = Config(1:linksN,i+1) + ( ( Config(1:linksN,i)-Config(1:linksN,i+1) )/2);
            
         [Manip, Man, fT, lT, lRot, lTrans, DH, LinLimits, JALimits] =...
         makeRobot( mid(2:4), mid(5:10) ) ;%makeRobot(linValues, theta);
%         linValuesFinal = [DH(2,2) DH(3,2) DH(4,2)]';
%         thetaFinal = [DH(5,1) DH(6,1) DH(7,1) DH(8,1) DH(9,1) DH(10,1) ];
%         [notInUse1, notInUSe2 ]=limitCheckError(linValuesFinal, thetaFinal, LinLimits, JALimits);

%       drawRobot(1,[1 0 0], linksN, Manip, lRot, lTrans)


        if collisionCheckABB(linksN, obsN, Manip, lRot, lTrans, Obstacles, oRot, oTrans);
%             disp('Her var det kollisjon gitt');
            inter = true;
            type = 0;
            break;
        else
            newConfig = [newConfig mid Config(1:linksN,i+1)];
        end


    end
    if inter
        break
    end
    intervalLin =  max(abs(newConfig(1:linksN-6,1) - newConfig(1:linksN-6,2) ) );
    intervalAngle =  max(abs(newConfig(5:linksN,1) - newConfig(5:linksN,2  ) ) );
    Config = newConfig;
    clear newConfig;
    teller = teller +1;
    
    if teller>100
        error('tull i feilen')
    end
        
end
w= [0 0.216 0.216 0.216 1.54 1.54 0.84 0.085 0.085 0.085];

confLen = length(Config(1,:));
if inter && configDist(Config(:,1), Config(:,confLen),w)<3

    %potPlannerConfigToConfig returns true if a collision free path is found
    if potPlannerConfigToConfigNew(Config(2:4,1), Config(5:10,1), Config(2:4,confLen), Config(5:10,confLen))
        if potPlannerConfigToConfigNew(Config(2:4,confLen), Config(5:10,confLen), Config(2:4,1), Config(5:10,1))
            disp('Potential field planner succeeded both ways')
            inter = false;
            type = 2;
        else
%             disp('Potential field planner succeeded only one way')
        end
    else
%         disp('Potential field planner failed.........')
    end
end
