% Checks for collision between manipulator and Obstacles

function [inter] = collisionCheckABB(linksN, obsN, Manip, lRot, lTrans, Obstacles, oRot, oTrans )  

for l=4:linksN
    for o =1:obsN
        %Initializing
        vInit = [ 2 -6 3]';
        %Check for collision
        inter  = gjkInterBoxCyl(vInit, Manip(l,:), lRot(:,:,l), lTrans(:,:,l), Obstacles(o,1), Obstacles(o,2), oRot(:,:,o), oTrans(:,:,o) );
        if inter
            break;
        end
    end

    if inter
        break;
    end
end