% Connectin Sampling Analytsis

function  conSamp_Analysis(Components, Samples)

[bComp bSamples] = removeEmptyComponents(Components,Samples,2);


linValues = [5 -2 -0.5]';     
thetaStart = [pi/3 pi/6 -pi/6 pi/8 -pi/4 pi/6]';
[Manip, Man, fT, lT, lRot, lTrans, DH, LinLimits, JALimits] = makeRobot(linValues, thetaStart);
w= [0 0.216 0.216 0.216 1.54 1.54 0.84 0.085 0.085 0.085];

step = 0.5;
stepVec = [0.1 0.25 0.1 01];
teller = 1;

for i = 1:10
i
pre_numberOfComponents(i) = length(bComp);
    
[cSamples, cComp, difficultWeight, lenInterMedVec, exTime] = connectionSamplingComp(bSamples, bComp, step,w, LinLimits, JALimits, 1, 5*pi/180);

[dComp dSamples] = removeEmptyComponents(cComp,cSamples,1);

[testConfigCovered, TestQueryConnection, ConnectionTime, PathSearchTime, testWidth ] = PRM_SamplingAnalysis(dComp, dSamples, w);

post_numberOfComponents(i) = length(dComp)
executionTime(i) = exTime
interMedOccations(i) = lenInterMedVec;
post_configsCovered(i,:) = testConfigCovered;
post_QueryConnections(:,:,i) = TestQueryConnection;
sumColums = sum(TestQueryConnection);
sumQueriesConnection(i) = sum(sumColums)



 teller = teller + 1;
    if teller ==6
        teller =1;
        step = stepVec(i/5);
    end

end
