%testing

function configConnectionTest(Theta)

Manip = 0.5*[ 5.10 6.15 5.10 
              7.05 2.00 2.00
              2.50 2.00 3.60
              1.50 9.35 1.50  ];
          
Man = 0.5*[ 0.00 6.15 0.00
            7.05 0.00 0.00
            0.00 0.00 3.60
            0.00 9.35 0.00  ];   
for i =1:2

    
  DH = [Theta(1,i)       6.15  1.00  -pi/2
                      Theta(2,i)-pi/2  0.00  7.05  0
                      Theta(3,i)       0.00  1.35  -pi/2
                      Theta(4,i)       7.55  0.00  pi/2];

                % Making transformation matrices for the joint frames
                [fT, fRot, fTrans ] = dh(DH);
                % Making transformation matrices for the links
                [lfT, lfRot, lfTrans ] = dhLinkABB(fT,Manip,Man);
                
                figure(1)
                hold on
%                 plot3( [fT(1,4,1) fT(1,4,2) fT(1,4,3) fT(1,4,4)],[fT(2,4,1) fT(2,4,2) fT(2,4,3) fT(2,4,4) ],[fT(3,4,1) fT(3,4,2) fT(3,4,3) fT(3,4,4)],'r')


 % Making the link objects in final pose for visualization

[xlink1f ylink1f zlink1f] = linkTransf( Manip(1,1), Manip(1,2), Manip(1,3) , lfRot(:,:,1), lfTrans(:,:,1) );
[xlink2f ylink2f zlink2f] = linkTransf( Manip(2,1), Manip(2,2), Manip(2,3) , lfRot(:,:,2), lfTrans(:,:,2) ); % -  fRot(:,:,2)*[Manip(2,1) 0 0 ]' ) );
[xlink3f ylink3f zlink3f] = linkTransf( Manip(3,1), Manip(3,2), Manip(3,3) , lfRot(:,:,3), lfTrans(:,:,3) ); %- fRot(:,:,3)* [ Manip(3,1) 0 0]' )); % - [0 DH(3,3)/2 DH(3,2)/2]' ) );    
[xlink4f ylink4f zlink4f] = linkTransf( Manip(4,1), Manip(4,2), Manip(4,3) , lfRot(:,:,4), lfTrans(:,:,4) ); %- fRot(:,:,3)* [ Manip(3,1) 0 0]' )); % - [0 DH(3,3)/2 DH(3,2)/2]' ) );    

 % Drawing the maipulttor in its final pose
patch(xlink1f, ylink1f, zlink1f, [1 0 0]);
patch(xlink2f, ylink2f, zlink2f, [1 0 0]);
patch(xlink3f, ylink3f, zlink3f, [1 0 0]);
patch(xlink4f, ylink4f, zlink4f, [1 0 0]);

end

    