% Connects the node to a component

function [success Samples comp emptyComp] = connectNode(con, c,ind, Samples, comp, sortMat, emptyComp)
    success = false;
if Samples(5,con) == 0 % If the node does not belong to a component
    comp(c).Node = [comp(c).Node; con];
    comp(c).NB   = [comp(c).NB; sortMat(ind,2)];
    Samples(5,con)=c; %sample con belongs to component c
    Samples(6,con)=sortMat(ind,1);
    success = true;
    return   % Done connecting to this component

elseif Samples(5,con)~=c % If the node allready belongs to a component: Merge the components
        
    comp(c).NB(1) = con;     
    comp(Samples(5,con)).Node = [comp(Samples(5,con)).Node; comp(c).Node];
    comp(Samples(5,con)).NB   = [comp(Samples(5,con)).NB; comp(c).NB];
    
    % Upgrading the belonging
    % component of each sample
    for teller=1:length(comp(c).Node)
        Samples(5,comp(c).Node(teller)) = Samples(5,con);
    end
    Samples(6,comp(c).Node(1))=sortMat(ind,1);
    comp(c).Node = false;  % "clear" the current component
    comp(c).NB   = 'empty';
    if emptyComp(1) == false;
        emptyComp(1) = c;
    else
        emptyComp = sort([emptyComp c]);
    end
    success = true;
    %return; % Done connecting to this component
end
