% Connects the node to a component

function [success Samples comp emptyComp] = connectNodeABB(con, c,ind, Samples, comp, sortMat, emptyComp)
    
% con is the current configuration/sample trying to connect to component c
% ind is the node con is connecting to 

success = false;
%     [row col] = size(comp(c).NB);
if Samples(11,con) == 0 % If the node does not belong to a component
    
    disp(['kobler configurasjon ' int2str(con) ' til node ' int2str(sortMat(ind,2))...
        ' i component ' int2str(c)] );  
    
    comp(c).Node = [comp(c).Node; con];   
    comp(c).NB(con,sortMat(ind,2) ) = sortMat(ind,1);
    comp(c).NB(sortMat(ind,2), con) = sortMat(ind,1);
    Samples(11,con) = c; %sample con belongs to component c
%     Samples(12,con) = sortMat(ind,1);
    success = true;
    return   % Done connecting to this component
    
% elseif Samples(11,con)==c
%     disp(['kobler configurasjon ' int2str(con) ' til node ' int2str(sortMat(ind,2))...
%         ' i component ' int2str(c)] );  
%     
% %     comp(c).Node = [comp(c).Node; con];   
%     comp(c).NB(con,sortMat(ind,2) ) = sortMat(ind,1);
%     comp(c).NB(sortMat(ind,2), con) = sortMat(ind,1);
%     success = true;
    
elseif Samples(11,con)~=c % If the node allready belongs to a component: Merge the components
%     disp('Merge two components together....')
%     A = comp(Samples(11,con)).NB
%     B = comp(c).NB

    if size(comp(Samples(11,con)).NB)>=size(comp(c).NB) %Merge the smallest component into the biggest
        disp('Merge two components together....method A')
        disp(['kobler component ' int2str(c) ' til component ' int2str(Samples(11,con))...
        ' mellom node ' int2str(sortMat(ind,2)) ' og node ' int2str(con)] );
        
%         disp('den lille componeten')
%         comp(c).NB
%         disp('den store componenten')
%         comp(Samples(11,con)).NB         

        len = length(comp(c).NB);
        comp(Samples(11,con)).NB(1:len,1:len)= comp(Samples(11,con)).NB(1:len,1:len)+comp(c).NB;
        comp(Samples(11,con)).NB(con, sortMat(ind,2)) = sortMat(ind,1);
        comp(Samples(11,con)).NB(sortMat(ind,2), con) = sortMat(ind,1);
       
        for teller=1:length(comp(c).Node)
            Samples(11,comp(c).Node(teller)) = Samples(11,con);             
        end
        % Overfrer de nye nodene
        comp(Samples(11,con)).Node = [comp(Samples(11,con)).Node ; comp(c).Node]; 
        
%         Samples(12,comp(c).Node(1))=sortMat(ind,1);
        % "clear" the current component
        comp(c).Node = false;  
        comp(c).NB   = 'empty';
        if emptyComp(1) == false;
            emptyComp(1) = c;
        else
            emptyComp = sort([emptyComp c]);
        end
        success = true;
        %return; % Done connecting to this component
        
    else
        disp('Merge two components together....method B')
        len = length(comp(Samples(11,con)).NB);              
        
       
        comp(c).NB(1:len,1:len)= B(1:len,1:len)+comp(Samples(11,con)).NB;
        comp(c).NB(con,sortMat(ind,2)) = sortMat(ind,1);
        comp(c).NB(sortMat(ind,2),con) = sortMat(ind,1);
                
        for teller=1:length( comp(Samples(11,con)).Node )
            Samples(11,comp(Samples(11,con)).Node(teller)) = c;             
        end
        % Overfre de nye nodene
        comp(c).Node = [comp(c).Node ; comp(Samples(11,con)).Node];
        % "clear" the current component
        comp(Samples(11,con)).Node = false;  
        comp(Samples(11,con)).NB   = 'empty';
        if emptyComp(1) == false;
            emptyComp(1) = Samples(11,con);
        else
            emptyComp = sort([emptyComp Samples(11,con) ]);
        end
        success = true;
    end  
    
end
