
function [startNode, goalNode, Samples, theComp, successArray]= connectStartGoalPointNew(startCon, goalPoint, goalPoint2, Samples, Components, weigthVec, Obstacles, linksN, obsN, oRot, oTrans,fig)

successArray = [0 0 0];
startConnected = false;
goalConnected = false;
len = length(Components);
startNode = length(Samples)+1;
goalNode = startNode + 1;
Config(1:10,1) = startCon;
% Config2(1:10,1)= goalCon;
% makeAndDrawRobot(startCon(2:4), startCon(5:10), 1, [ 0 1 0])
% makeAndDrawRobot(goalCon(2:4), goalCon(5:10), 1, [ 0 0 1])

% Finding the length of each component
for i=1:len
   compMat(i,1:2) = [length(Components(i).Node) i]; 
end
% Sorting the components in descending order
compMat = sortrows(compMat,[-1]); 

% Try connect to a component, the largest first
for k = 1:len
    i = compMat(k,2); % A little tweak...
    
    % Sorting the nodes in ascending order by distance from start node
        clear TempMat;
        for teller = 1:length(Components(i).Node) %Computing distance to all nodes in  one component
            TempMat(teller,:) = [configDist(startCon, Samples(1:10, Components(i).Node(teller) ), weigthVec ), teller ]; %Components(i).Node(teller) ];
        end

        % Sort the matrix with increasing distance
        clear sortMat;
        sortMat = sortrows(TempMat);
        
    for p = 1:length(Components(i).Node ) 
        j = sortMat(p,2);
        
        if Components(i).Node(j)==0
            disp('Empty component')
            break;
        end      
        
        tryCon = Samples(1:10,Components(i).Node(j)); % The configuration trying to connect to        
        % Try connect start configuration
        if ~startConnected
            Config(1:10,2) = tryCon;    
            if ~binCollisionCheckABB( Config,1, 5*pi/180,linksN, obsN, Obstacles, oRot, oTrans);
                Samples(1:10,startNode) = startCon;
                Samples(11,startNode) = i;
                startDist = configDist(startCon,tryCon, weigthVec );
                Components(i).NB(Components(i).Node(j), startNode ) = startDist;   %Adding the new distance
                Components(i).NB(startNode, Components(i).Node(j) ) = startDist;   %Adding the new distance
                Components(i).Node = [Components(i).Node; startNode ]; %Adding the new node
                
%                 makeAndDrawRobot(tryCon(2:4), tryCon(5:10), 1, [ 0 1 0])
%                 makeAndDrawRobot(tryCon(2:4), tryCon(5:10), 2, [ 0 1 0])
                startConnected = true;
                successArray(1) = 1;
            end
        end
    end
    % try connect to the goal point
    
    % Sorting the nodes in ascending order
        clear TempMatGoal;
        for teller = 1:length(Components(i).Node) %Computing distance to all nodes in  one component
            
            linValues = Samples(2:4,Components(i).Node(teller));
            theta = Samples(5:10,Components(i).Node(teller)); 
            
            [Manip, Man, fT, lT, lRot, lTrans, DH, LinLimits, JALimits] = makeRobot(linValues, theta );
            
            endEffectorPoint = fT(1:3,4,10); 
            
            TempMatGoal(teller,:) = [ norm(goalPoint-endEffectorPoint) teller]; 
        end

    % Sort the matrix with increasing distance
        clear sortMatGoal;
        sortMatGoal = sortrows(TempMatGoal);
%         sortMatGoal = sortMatGoal(1:100,:);
    % Try connecting the "closest" configuration
    
        for p = 1:length(Components(i).Node ) 
            p
            if p>15
                break
            end
            j = sortMatGoal(p,2); 
            
            if Components(i).Node(j)==0
                disp('Empty component')
                break;
            end      
        
            tryCon = Samples(1:10,Components(i).Node(j)); % The configuration trying to connect to
            
            [success linValues theta] = connectToPointPlannerOrientNew(goalPoint, goalPoint2, tryCon(2:4), tryCon(5:10),fig );
            
%                         [success linValues theta] = connectToPointPlannerLast(goalPoint, tryCon(2:4), tryCon(5:10), fig );
            if success
                Samples(2:4,goalNode) = linValues;
                Samples(5:10,goalNode) = theta;
                Samples(11,goalNode) = i;
                goalDist = configDist([0; linValues; theta],tryCon, weigthVec );
                Components(i).NB(goalNode, Components(i).Node(j) ) = goalDist;  %Adding the new distance
                Components(i).NB(Components(i).Node(j), goalNode ) = goalDist;  %Adding the new distance
                Components(i).Node = [Components(i).Node; goalNode ]; %Adding the new node

%                 makeAndDrawRobot(tryCon(2:4), tryCon(5:10), 1, [ 0 0 1])
%                 makeAndDrawRobot(tryCon(2:4), tryCon(5:10), 2, [ 0 0 1])
                goalConnected = true;
                successArray(2) = 1;
                break; % Stop try connect to goalPoint
            end
    
        end % Done trying connecting
        
        % Checks if connected to same component
        if startConnected && goalConnected
            if Samples(11,startNode) == Samples(11, goalNode)
                theComp = Components(i);
                successArray(3) = 1;
                disp('Succsessfully connected start and goal configuration')
                return
            else
                successArray(3) = 0;
                error('Start and goal node not connected to same configuration')

            end
        end
        
        if startConnected && ~goalConnected
            disp('Could only connect start configuration to this component . Try again')
            startConnected = false;
        elseif ~startConnected && goalConnected
            disp('Could only connect goal configuration to this component. Try again')
            goalConnected = false;
        end
end
theComp = 0;
successArray(3) = 0;

% if ~startConnected && ~goalConnected
%     error('Could not connect start and goal configuration')
% elseif ~startConnected
%     error('Could not connect start configuration')
% elseif ~goalConnected
%     error('Could not connect goal configuration')
% end
        
        