% Denavit-Hartenberg
% Returning the Transformation and rotation matrices
% and the translation vector.


function [T rot trans] = dh(DH)

[dhLength dhWidth] = size(DH);

for i=1:dhLength

    if i==1
        T(:,:,1) =[cos(DH(i,1)) -sin(DH(i,1))*cos(DH(i,4))  sin(DH(i,1))*sin(DH(i,4)) DH(i,3)*cos(DH(i,1))
            sin(DH(i,1))  cos(DH(i,1))*cos(DH(i,4)) -cos(DH(i,1))*sin(DH(i,4)) DH(i,3)*sin(DH(i,1))
            0            sin(DH(i,4))          cos(DH(i,4))        DH(i,2)
            0               0               0            1      ];
    else
        T(:,:,i) = T(:,:,i-1)*[cos(DH(i,1)) -sin(DH(i,1))*cos(DH(i,4))  sin(DH(i,1))*sin(DH(i,4)) DH(i,3)*cos(DH(i,1))
                               sin(DH(i,1))  cos(DH(i,1))*cos(DH(i,4)) -cos(DH(i,1))*sin(DH(i,4)) DH(i,3)*sin(DH(i,1))
                                 0            sin(DH(i,4))          cos(DH(i,4))        DH(i,2)      
                                 0               0               0            1      ];
    end    
end

rot = T(1:3,1:3,:);

trans = T(1:3,4,:);


