function  [distance] = getConfigDist(aTheta, bTheta ,w)

  distance1 = 0;
  distance2 = 0;
if length(aTheta) == length(w) && length(aTheta) == length(bTheta)
    
    for i=2:4
        distance1 = distance1 + ( w(i)*abs( aTheta(i)-bTheta(i) ) )^2;        
    end
    distance1 = distance1^0.5;
    
    for i=4:length(aTheta)
        if i==10
            distVec = [abs(aTheta(i)-bTheta(i))
                       aTheta(i)-bTheta(i)+2*pi
                       bTheta(i)-aTheta(i)+2*pi ];
            distance2 = distance2 + ( w(i)*min(distVec) )^2;
        else
            distance2 = distance2 + ( w(i)*abs( aTheta(i)-bTheta(i) ) )^2;
        end
    end
    distance2 = distance2^0.5;
else
    error('w and depth are not of equal length');
end

distance = distance1 + distance2;
