

function [nbNodes] = getNBNodes(lim,position, boxStruct)

% lim=3;

pos(1) = ceil(position(1));
pos(2) = ceil(position(2));
pos(3) = ceil(position(3));

[xL yL zL] = size(boxStruct);

xMin=pos(1)-lim;
if xMin<1
    xMin = 1;
end
xMax = pos(1)+lim;
if xMax>xL
    xMax=xL;
end

yMin=pos(2)-lim;
if yMin<1
    yMin = 1;
end
yMax = pos(2)+lim;
if yMax>yL
    yMax=yL;
end

zMin=pos(3)-lim;
if zMin<1
    zMin = 1;
end
zMax = pos(3)+lim;
if zMax>zL
    zMax=zL;
end

nbNodes = [];
for z=zMin:zMax
    for y=yMin:yMax
        for x=xMin:xMax
            if ~isempty(boxStruct(x,y,z).Nodes)
                nbNodes = [nbNodes boxStruct(x,y,z).Nodes];
            end
        end
    end
end

