clear all
figure(5)
hold off
plot3(0,0,0,'o');
hold on
      

R(:,:,1)  = box(2,2,2);
Cyl = [1 8];

RMat = [pi/-2 pi/2 pi/6   4 3 7];
[RT RRot RTrans] = obsTransformation(RMat);

cylMat = [pi/2 pi/7 0 -4 0 -4];
[cylT cylRot cylTrans] = obsTransformation(cylMat);
   


            
            % Finding an initial vector inside A-B using the Supportpoints             
             avec = [ 2 6 3]';
             wR   = supportPoint(-avec, R(:,:,1), RRot(:,:,1), RTrans(:,:,1));
             wObs = supportPointCyl(avec, Cyl(1), Cyl(2), cylRot(:,:,1), cylTrans(:,:,1));  
             a = wR-wObs; 
             
             bvec = [ 2 -6 3]';
             wR   = supportPoint(-bvec, R(:,:,1), RRot(:,:,1), RTrans(:,:,1));   
             wObs = supportPointCyl(bvec, Cyl(1), Cyl(2), cylRot(:,:,1), cylTrans(:,:,1));  
             b = wR-wObs;             
             
             c = a-b;
             vInit = b + 0.5*c; 
%              figure(6)
%              hold on
%              plot3([vInit(1) 0], [vInit(2) 0], [vInit(3) 0],'y');   
                            
             %Extract the disatance, direction, closest point on R obstacle
             [inter dist v r obs ] = gjkBoxCyl(vInit, R(:,:,1), RRot(:,:,1), RTrans(:,:,1), Cyl(1), Cyl(2), cylRot(:,:,1), cylTrans(:,:,1) );
            
 figure(5) 
 hold on
 plot3([obs(1) r(1)], [obs(2) r(2)], [obs(3) r(3)],'k');
 plot3(obs(1), obs(2), obs(3), 'r o');
 plot3(r(1), r(2), r(3), 'h k');
 
%  figure(6)
%  hold on
%  plot3([v(1) 0], [v(2) 0], [v(3) 0],'g');


   
[ RX RY RZ] = boxf( R(:,:,1), RRot(:,:,1), RTrans(:,1) );
drawCylinder(5, Cyl(1), Cyl(2), cylRot(:,:,1), cylTrans(:,:,1) );
%[ ObsX ObsY ObsZ] = boxf(Obs(:,:,1), ObsRot(:,:,1), ObsTrans(:,1) );
% [x,y,z] = ellipsoid(ObsTrans(:,:,1),norm(Obs(1,1,1)),norm(Obs(1,1,1)),norm(Obs(1,1,1)));
%ellipsoid(ObsTrans(1,1,1),ObsTrans(2,1,1),ObsTrans(3,1,1),norm(Obs(1,1,1)),norm(Obs(1,1,1)),norm(Obs(1,1,1)));
%surfl(x, y, z);
figure(5)
%plot3( R1Trans(:,1), R1trans(:,2), R1trans(:,3), 'o' );
%patch( R1Trans(:,1), R1trans(:,2), R1trans(:,3), [ 0 1 0] );
 patch(RX, RY, RZ, [0 1 0]);
 hold on
%  patch(ObsX, ObsY, ObsZ, [1 0 0])
 axis([-10 10 -10 10 -10 10]);
 %surf(cylX, cylY, cylZ)
 hold off;
 %figure(6)
 %hold off