function [inter ] = gjkInterBoxCyl(v,R, rRot, rTrans, radius, len, obsRot, obsTrans)
                                 
W(1:4,1:3,1) = zeros; 
wR   = supportPoint(-v, R(:,:,1), rRot,rTrans);   
wObs = supportPointCyl(v, radius, len, obsRot, obsTrans);  
w = wR-wObs;
WR(1,:)=wR'; WObs(1,:) = wObs'; %Keeping each objects support point. 
W(1,:,1) = w' ;
v=w;
vectors(1,:)=v';
freeIndex = 2;
maxIt = 20;
repetition = false;
inter = true;
 
for i=2:maxIt %Use for loop to avoid infinte loop
      
    [v Wmatrix lambda freeIndex] = shortDist(W(:,:,i-1),1);
    
    wR   = supportPoint(-v, R(:,:,1), rRot,rTrans);
    wObs = supportPointCyl(v, radius, len, obsRot, obsTrans);
    w = wR-wObs;
    WR(i,:)=wR'; WObs(i,:) = wObs'; %Keeping each objects support point.
            
    %Check if there exist a separating axis
        
    if v'*w > 0
        inter = false;
        %disp('No collision detected')
        break;
    elseif i == maxIt
        %disp('No separating axis found, collision detected')
    end
    
    W(:,:,i) = Wmatrix;
    W(freeIndex,:,i) = w';
    
end
    