% Interpolation

function [tempTheta] = interpolAndDraw(aTheta, bTheta, interval)

steps=abs(aTheta-bTheta)/interval;
    f=1/max(steps);
    if f<0.0001
        error('f er lik null')
    end
    index = 1;
    if f>=0.5
        tempTheta(1:4,index) = aTheta +f*(bTheta-aTheta);
    else
        for i =f:f:1-f            
            tempTheta(1:4,index) = aTheta +i*(bTheta-aTheta);
            index = index +1;
        end
    end
 