%Computing the transposed Jacobian from base to joint 2

function [J] = jacobianT02(DH)

s1 = sin( DH(1,1) );
s2 = sin( DH(2,1) );
c1 = cos( DH(1,1) );
c2 = cos( DH(2,1) );


a2 = DH(2,3);

J = [-a2*s1*c2 a2*c1*c2            0
    -c1*a2*s2 -s1*a2*s2 a2*c2
    0             0                0            ];


%a2*s1^2*c2+a2*c1^2*c2
% J = [-a2*sin( DH(1,1) )*cos( DH(2,1) ) a2*cos( DH(1,1) )*cos( DH(2,1) ) 0
%     -cos( DH(1,1) )*a2*sin( DH(2,1) ) -sin( DH(1,1) )*a2*sin( DH(2,1) ) a2*sin( DH(1,1) )^2*cos( DH(1,1) ) + a2*cos( DH(1,1) )^2*cos( DH(2,1) )
%     0             0                    0        ]