% Tests the binary collision detetor

 clear all;
figure(1)
hold off
plot3(0,0,0,'o')
hold on

% Makes some obstacles
[Obstacles oT oRot oTrans obsN] = makeObstaclesTest();

% Makes the robot in final position
linksN = 10;
finalPos = [-5 -10 -4]';
thetaFinal = [pi/3 -pi/2 -pi/7 pi/4 pi/4 pi/6];
[Manip, Man, ffT, lfT, lfRot, lfTrans, DenHaf, LinLimits, JALimits] = makeRobot(finalPos, thetaFinal);
drawRobot(1,[1 0 0], linksN, Manip, lfRot, lfTrans)   
% Makes the  robot in its initial position  
    %%%%%% Initial pose %%%%%%%
linValues = [5 14 -0.5]';     
thetaStart = [pi/3 pi/6 -pi/6 pi/8 -pi/4 pi/6]';
[Manip, Man, fT, lT, lRot, lTrans, DH, LinLimits, JALimits] = makeRobot(linValues, thetaStart);
drawRobot(1,[1 0 0], linksN, Manip, lRot, lTrans)
% theta = [DH(5,1) DH(6,1) DH(7,1) DH(8,1) DH(9,1) DH(10,1)]';

% %% Probabilisitc road map
%  [Samples Components] = makeSamplesABB(LinLimits, JALimits, 60/180*pi, Obstacles, oRot, oTrans);

Config(2:4,1) = finalPos;

Config(5:10,1)= thetaFinal;
Config(2:4,2) = linValues;
Config(5:10,2)= thetaStart;

 interaction = binCollisionCheckABB( Config, 1, 5*pi/180,linksN, obsN, Obstacles, oRot, oTrans);