% Makes obstacles

function [Obstacles oT oRot oTrans obsN] = makeObstaclesTest(figur)
 %figur=6;

Obstacles =[6   16
            0.4 12
            0.4 12
            0.4 12
            0.4 12
            0.4 8
            0.4 14
            3   16
            4   14
            0.4 12
            0.4 24
            0.4 4
            0.4 4
            0.4 4
            0.4 6
            0.4 4
            0.4 16
            0.4 6
            0.4 30
            0.4 4
            0.4 4
            0.4 6
            0.4 4
            0.4 16
            0.4 4
            0.4 30
            1    8 %box
            1    8 %box
            1   12 %box
            1   12 %box
            0.4 24 %rr langs
            0.4 20 %rr bort
%             0.4 24 %rr langs
           % 0.4 20 %rr bort
            ];
                 
ObsMat = [0 pi/2 0   0 0 16
          0 0 0     -6 -3 6
          0 0 0     -6  3 6
          0 0 0      6 -3 6
          0 0 0      6  3 6
          0 pi/2 0  12  0 14
          0 0 0     16  0 7
          0 0 0     12  6 8
          0 0 0     22 0 7
          0 0 0     22 0 20
          0 pi/2 0  10  0 26
          0 0 0    -2  0  24
          0 0 0    -6  0  24 %opp
          pi/2 0 0 -6 -2  26 %bort
          0 0 0    -6 -4  23 %ned
          pi/2 0 0 -6 -6  20 %bort
          0 0 0    -6 -8  12 %ned
          pi/2 0 0 -6 -11 4  %bort
          0 pi/2 0  9 -14 4  %langs
          0 0 0    -4  0  24 %opp
          pi/2 0 0 -4 -2  26 %bort
          0 0 0    -4 -4  23 %ned
          pi/2 0 0 -4 -6  20 %bort
          0 0 0    -4 -8  12 %ned
          pi/2 0 0 -4 -10 4  %bort
          0 pi/2 0  11 -12 4 %langs
          0 0 0    14  -14 8 %box
          0 0 0    20  -14 8 %box
          0 0 0    10  -12 10 %box
          0 0 0    16  -12 10 %box
          0 pi/2 0 10  -10 10 %langs
          pi/2 0 0  14    0 10 %bort
%           0 pi/2 0 10  -10 20 %langs
          %pi/2 0 0  18    0 2|0 %bort
          ];
      
% ObsMat(:,4:6) = ObsMat(:,4:6)*2.0; 

for i=1:length(ObsMat)
    ObsMat(i,4:6) = ObsMat(i,4:6) + [40 45 0]; 
end      

numObs =size(Obstacles);

    %Making transformation Matrices for the obstacles
[oT oRot oTrans] = obsTransformation(ObsMat);

[obsN notInUse2] = size(Obstacles);

%     % Drawing the Obstacles   
%        
%     for i=1:obsN
%         drawCylinder(figur, Obstacles(i,1), Obstacles(i,2), oRot(:,:,i), oTrans(:,:,i) );
%     end

%     axis([0 100 0 100 0 100]);