% Moves the robot manilpulator one desired "step" in random direction

function [newConfig jointAngles] = moveRandStep(step,w, config, LinLimits, JALimits)

randVec = 0.175*rand(10,1);
randVec(3,1) =0; 
randVec(1,1) = 0;
sumVec = sum( randVec(1:10) );
randVec(3,1) = 1-sumVec;

% if sum(randVec)~=1 %|| randVec(5)<0
%     error('random vektor ikke sum lik 1')
% end

deNum = 0;
for i=1:10
   deNum = deNum + (randVec(i)*w(i))^2; 
end

jointAngles = randVec* (step/sqrt(deNum));  

newConfig = config + jointAngles;

%  newDist = configDist(config, newConfig, w)

%  Checks that newConfig does not exceed joint limits
LinLimits(3,1:2) = LinLimits(3,1:2) + 6.3+8;
JALimits(2,1:2) = JALimits(2,1:2) + pi/2;
% JALimits(3,1:2) = JALimits(3,1:2);

[linValues, theta]=limitCheck(newConfig(2:4), newConfig(5:10), LinLimits, JALimits);

newConfig(2:4) = linValues;
newConfig(5:10)= theta;

% newDistTwo = configDist(config, newConfig, w)