

function [oT oRot oTrans] = obsTransformation(obsMat)

[row kol]= size(obsMat);

for i =1:row

    thetaX = obsMat(i,1);
    thetaY = obsMat(i,2);
    thetaZ = obsMat(i,3);
    RotX = [1      0           0
            0 cos(thetaX) -sin(thetaX)
            0 sin(thetaX)  cos(thetaX) ];
        
    RotY = [ cos(thetaY) 0  sin(thetaY)
                 0       1     0
            -sin(thetaY) 0  cos(thetaY)];
        
    RotZ = [cos(thetaZ) -sin(thetaZ) 0 
            sin(thetaZ) cos(thetaZ)  0
                  0         0        1];     
               
    oRot(:,:,i) = RotX*RotY*RotZ;
    oTrans(:,1,i) = [obsMat(i,4) obsMat(i,5) obsMat(i,6)]';

    oT(1:4,1:4,i) = [oRot(:,:,i) oTrans(:,1,i)
                      0    0    0       1      ];

end
