% function plotRobotFrames()
fig=1;
figure(fig)
    hold on
%     axis([-10 20 -10 50 -10 50]);
linValues = [0 5 4]';     
thetaStart = [-pi/4 pi/7 pi/9 0 pi/4 pi/4];%[pi/6 pi/5 pi/5 pi/2 -pi/5 pi/9]';
[Manip, Man, fT, lT, lRot, lTrans, DH, LinLimits, JALimits] = makeRobot(linValues, thetaStart);

makeAndDrawRobot(linValues, thetaStart, fig, [1 1 1])
drawGantryCrane(fig, fT, linValues(1))

alpha(0)
% plot3([fT(1,4,3) fT(1,4,4)],[fT(2,4,3) fT(2,4,4)],[fT(3,4,3) fT(3,4,4)],'k')
% plot3([fT(1,4,4) fT(1,4,4)+1],[fT(2,4,4) fT(2,4,4) ],[fT(3,4,4) fT(3,4,4) ],'k')
% plot3([fT(1,4,4)+1 fT(1,4,5)],[fT(2,4,4) fT(2,4,5) ],[fT(3,4,4) fT(3,4,5) ],'k')
% plot3([fT(1,4,5) fT(1,4,6)],[fT(2,4,5) fT(2,4,6)],[fT(3,4,5) fT(3,4,6)],'k')
% plot3([fT(1,4,6) fT(1,4,7)],[fT(2,4,6) fT(2,4,7)],[fT(3,4,6) fT(3,4,7)],'k')
% plot3([fT(1,4,7) fT(1,4,8)],[fT(2,4,7) fT(2,4,8)],[fT(3,4,7) fT(3,4,8)],'k')
% plot3([fT(1,4,8) fT(1,4,9)],[fT(2,4,8) fT(2,4,9)],[fT(3,4,8) fT(3,4,9)],'k')
%     
%       x y z
init = [0 0 0
        0 0 0
        0 0 0];

%       x y z
goal = [5 0 0
        0 5 0
        0 0 5 ];
    
left = [-2 -1 -1
        -1 -2 0
         0  0 -2];
  
right = [2 1 1
         1 2 0
         0 0 2];
     

    plot3([init(1,1) goal(1,1)],[init(2,1) goal(2,1)],[init(3,1) goal(3,1)],'r');
    plot3([init(1,2) goal(1,2)],[init(2,2) goal(2,2)],[init(3,2) goal(3,2)],'g');
    plot3([init(1,3) goal(1,3)],[init(2,3) goal(2,3)],[init(3,3) goal(3,3)],'k');
    plot3(init(1,3), init(2,3),init(3,3) ,'k .');
        
for i=1:10    
%     plot3([init(1,1) goal(1,1)],[init(2,1) goal(2,1)],[init(3,1) goal(3,1)],'r');
%     plot3([init(1,2) goal(1,2)],[init(2,2) goal(2,2)],[init(3,2) goal(3,2)],'g');
%     plot3([init(1,3) goal(1,3)],[init(2,3) goal(2,3)],[init(3,3) goal(3,3)],'b');
    %       x y z
init = [0 0 0
        0 0 0
        0 0 0];

%       x y z
goal = [6-i/3 0 0
        0 6-i/3 0
        0 0 6-i/3 ];
%     rot = [1 0 0 
%            0 1 0 
%            0 0 1 ];
%    trans = [20 20 20
%             20 20 20
%             20 20 20 ];
rot = fT(1:3,1:3,i);
trans(1:3,1) = fT(1:3,4,i); %ft(1:3,1:3,4) ft(1:3,1:3,4) ]
trans(1:3,2) = fT(1:3,4,i);
trans(1:3,3) = fT(1:3,4,i);

%  plot3(fT(1,4,i), fT(2,4,i), fT(3,4,i),' b o' );
     init = rot(1:3,1:3)*init + trans;
     goal = rot(1:3,1:3)*goal + trans;
     rotLeft  = rot(1:3,1:3)*left;
     rotRight = rot(1:3,1:3)*right;
     
     leftArr  = goal+left;
     rightArr = goal-right;
   
     
    plot3([init(1,1) goal(1,1)],[init(2,1) goal(2,1)],[init(3,1) goal(3,1)],' r');
%     plot3([init(1,2) goal(1,2)],[init(2,2) goal(2,2)],[init(3,2) goal(3,2)],'g');
    plot3([init(1,3) goal(1,3)],[init(2,3) goal(2,3)],[init(3,3) goal(3,3)],'k');
     plot3(init(1,3), init(2,3),init(3,3) ,'k .');
    
%     plot3([leftArr(1,1) goal(1,1)],[leftArr(2,1) goal(2,1)],[leftArr(3,1) goal(3,1)],'r');
%     plot3([leftArr(1,2) goal(1,2)],[leftArr(2,2) goal(2,2)],[leftArr(3,2) goal(3,2)],'g');
%     plot3([leftArr(1,3) goal(1,3)],[leftArr(2,3) goal(2,3)],[leftArr(3,3) goal(3,3)],'b');
%     
%     plot3([rightArr(1,1) goal(1,1)],[rightArr(2,1) goal(2,1)],[rightArr(3,1) goal(3,1)],'r');
%     plot3([rightArr(1,2) goal(1,2)],[rightArr(2,2) goal(2,2)],[rightArr(3,2) goal(3,2)],'g');
%     plot3([rightArr(1,3) goal(1,3)],[rightArr(2,3) goal(2,3)],[rightArr(3,3) goal(3,3)],'b');
%     
%     plot3( goal(1,1), goal(2,1), goal(3,1),'r <');
%     plot3( goal(1,2), goal(2,2), goal(3,2),'g <');
%     plot3( goal(1,3), goal(2,3), goal(3,3),'b <');
end 


plot3([fT(1,4,3) fT(1,4,4)],[fT(2,4,3) fT(2,4,4)],[fT(3,4,3) fT(3,4,4)],'b')
plot3([fT(1,4,4) fT(1,4,5)-1],[fT(2,4,4) fT(2,4,5)],[fT(3,4,4) fT(3,4,5)],'b')
plot3([fT(1,4,5)-1 fT(1,4,5)],[fT(2,4,5) fT(2,4,5)],[fT(3,4,5) fT(3,4,5)],'b')
plot3([fT(1,4,5) fT(1,4,6)],[fT(2,4,5) fT(2,4,6)],[fT(3,4,5) fT(3,4,6)],'b')
plot3([fT(1,4,6) fT(1,4,7)],[fT(2,4,6) fT(2,4,7)],[fT(3,4,6) fT(3,4,7)],'b')
plot3([fT(1,4,7) fT(1,4,8)],[fT(2,4,7) fT(2,4,8)],[fT(3,4,7) fT(3,4,8)],'b')
plot3([fT(1,4,8) fT(1,4,9)],[fT(2,4,8) fT(2,4,9)],[fT(3,4,8) fT(3,4,9)],'b')
% alpha(0)
 
axis([-10 50 -10 50 -10 50]);
