% Draws the two vertical bars of the gantry crane

function drawGantryCrane(fig, ffT, y)

Gant(:,:,1) = ffT(:,:,2);
Gant(:,:,2) = ffT(:,:,2);

Gant(1:3,4,1) = [20,  y, 38/2]';
Gant(1:3,4,2) = [-20, y, 38/2]';

Gantry= 0.5*[40.00 2.00 2.00];

[xlink1 ylink1 zlink1] = linkTransf( Gantry(1,1), Gantry(1,2), Gantry(1,3) , Gant(1:3,1:3,1), Gant(1:3,4,1) );
[xlink2 ylink2 zlink2] = linkTransf( Gantry(1,1), Gantry(1,2), Gantry(1,3) , Gant(1:3,1:3,2), Gant(1:3,4,2) );
    figure(fig)
    hold on
    patch(xlink1, ylink1, zlink1, [1 0 0]);
    patch(xlink2, ylink2, zlink2, [1 0 0]);

