function [inter dist v r obs] = gjk(v,R, rRot, rTrans, Obs, obsRot, obsTrans)

W(1:4,1:3,1) = zeros; 
wR   = supportPoint(-v, R(:,:,1), rRot,rTrans);   
wObs = supportPoint(v, Obs(:,:,1), obsRot, obsTrans);  
w = wR-wObs;
WR(1,:)=wR'; WObs(1,:) = wObs'; %Keeping each objects support point. 
W(1,:,1) = w' ;
v=w;
vectors(1,:)=v';
freeIndex = 2;
maxIt = 19;
repetition = false;
inter = false;
sepAxis=false;
 
    for i=2:maxIt %Use for loop to avoid infinte loop
      
        [v Wmatrix lambda freeIndex] = shortDist(W(:,:,i-1),1);                            
      
         wR   = supportPoint(-v, R(:,:,1), rRot,rTrans);   
         wObs = supportPoint(v, Obs(:,:,1), obsRot, obsTrans);  
         w = wR-wObs;        
         WR(i,:)=wR'; WObs(i,:) = wObs'; %Keeping each objects support point.
                         
         prodOne = v'*w;
         termi = norm(v)^2 - prodOne ;
         prod(i) = termi;         

         if prodOne > -0.001 
             sepAxis=true;
         end
        
         
         %Checks if the answer is alternateing.
%         if i>(maxIt-5) && prodOne >0 
         if i>(maxIt-5) && sepAxis
            
            if repeatCheck2(w,W(:,:,i-1))
                repetition = true;
            elseif repeatCheck2(w,W(:,:,i-2))
                repetition = true;
            elseif repeatCheck2(w,W(:,:,i-3))
                repetition = true;
            elseif repeatCheck2(w,W(:,:,i-4))
                repetition = true;
            elseif repeatCheck2(w,W(:,:,i-5)) %this should be enough
                repetition = true;    
            end
            
            if repetition                          
               
                repetition = true;
                dist=norm(v);
                break;
            end
        end
        %Checks if the answer is alternateing.
        if i>(maxIt-4) && sepAxis            
            
            if repeatCheck2(w,W(:,:,i-1))
                repetition = true;
            elseif repeatCheck2(w,W(:,:,i-2))
                repetition = true;
            elseif repeatCheck2(w,W(:,:,i-3))
                repetition = true;
            elseif repeatCheck2(w,W(:,:,i-4))
                repetition = true;
            elseif repeatCheck2(w,W(:,:,i-5)) %this should be enough
                repetition = true;    
            end
            
            if repetition                          
                repetition = true;
                dist=norm(v);
                break;
            end
        end
        
         %Checks if the answer is alternateing.
        if i>(maxIt-3) && sepAxis            
            
            if repeatCheck2(w,W(:,:,i-1))
                repetition = true;
            elseif repeatCheck2(w,W(:,:,i-2))
                repetition = true;
            elseif repeatCheck2(w,W(:,:,i-3))
                repetition = true;
            elseif repeatCheck2(w,W(:,:,i-4))
                repetition = true;
            elseif repeatCheck2(w,W(:,:,i-5)) %this should be enough
                repetition = true;    
            end
            
            if repetition            
                disp('Repeating answer')
                repetition = true;
                dist=norm(v);
                break;
            end
        end
        
         %Checks if the answer is alternateing.
        if i>(maxIt-2) && sepAxis            
            
            if repeatCheck2(w,W(:,:,i-1))
                repetition = true;
            elseif repeatCheck2(w,W(:,:,i-2))
                repetition = true;
            elseif repeatCheck2(w,W(:,:,i-3))
                repetition = true;
            elseif repeatCheck2(w,W(:,:,i-4))
                repetition = true;
            elseif repeatCheck2(w,W(:,:,i-5)) %this should be enough
                repetition = true;    
            end
            
            if repetition            
                disp('Repeating answer')
                repetition = true;
                dist=norm(v);
                break;
            end
        end
        
        
                 
        W(:,:,i) = Wmatrix;          
        W(freeIndex,:,i) = w';
        
          
            %Check for collision, if there not exists a separating axis
        if i>(maxIt-1)
            if prodOne < 0.00000001 
                dist = 0.1;
                disp(' **********INTERSECTION***********************');
                disp('no separating axis found')
                inter = true;
                break;
                %error(' INTERSECTION!!!')
            end
        end 
        
        if  termi < 0.0000001 && sepAxis    
            dist=norm(v);
            break;
        end      
        
        % Check that a closest distance is found 
        if i == maxIt
             dist=norm(v);
            inter = true;
            disp(' could not find closest distance' )
                break;
            %error(' could not find closest distance' )
        end
  
    end

    % Converting point from Minkowski sum to point on robot and obstacle
    
[Wl Ww Wd] = size(W);
[WRl WRw WRd] =size(WR);
       
 for j=1:length(lambda)   
    for i=1:WRl
        wTemp = WR(i,:)-WObs(i,:);
        if any((WR(i,:)-WObs(i,:)-W(j,:,Wd)))==0     
            rPoint(j,:)  = WR(i,:);
            obsPoint(j,:)= WObs(i,:);           
        end
    end
 end   
    r=0;
    obs=0;
    for i=1:length(lambda)
        r   = r   + lambda(i)*rPoint(i,:);
        obs = obs + lambda(i)*obsPoint(i,:);
    end  

    
    
    