% Makes obstacles

function [Obstacles oT oRot oTrans obsN] = makeObstaclesTest(figur)
%  figur=6;
% Obstacles = [1 14
%              2 8
%              1 10];
%     
% ObsMat= [pi/5     pi/9    0     6    0    20
%          0     pi/8    0     10   0   8%];
%          0     pi/3    pi/4      0   7   10];

Obstacles =2.0* [3  8   %tank
                 0.2 6  %bein
                 0.2 6  %bein      
                 0.2 6  %bein
                 0.2 6  %bein
                 0.2 4  %rr
                 0.2 7  %rr
                 1.5 8  %tank
                  2  7  %tank
                 0.2 6  %rr
                 0.2 12 %rr
                 0.2 2  %rr
                 0.2 3 
                 0.2 8
                 0.2 2
                  2  6];  
                 
ObsMat = [0 pi/2 0  0 0 8
          0 0 0 -3 -1.5 3
          0 0 0 -3  1.5 3
          0 0 0  3 -1.5 3
          0 0 0  3  1.5 3
          0 pi/2 0  6  0 7
          0 0 0     8 0 3.5
          0 0 0     6 3 4
          0 0 0     11 0 3.5
          0 0 0     11 0 10
          0 pi/2 0   5 0 13
          0 0 0     -1 0 12 
          pi/2 0 0   0 -3  8
          0 pi/2 0   4 -4.5  8
          0 0 0      8 -4.5  7
          0 0 0      8 -4.5  3];
      
      
ObsMat(:,4:6) = ObsMat(:,4:6)*2.0; 

for i=1:length(ObsMat)
    ObsMat(i,4:6) = ObsMat(i,4:6) + [40 45 0]; 
end

      

numObs =size(Obstacles);

    %Making transformation Matrices for the obstacles
[oT oRot oTrans] = obsTransformation(ObsMat);

[obsN notInUse2] = size(Obstacles);

    % Drawing the Obstacles
    
   
    
    for i=1:obsN
        drawCylinder(figur, Obstacles(i,1), Obstacles(i,2), oRot(:,:,i), oTrans(:,:,i) );
    end

%     axis([-20 20 -20 20 0 40]);