% New PRM planner

function PRM_3(Components, Samples)

figure(2)
hold off
plot3(0,0,0,'o')
hold on

linksN = 10;
% figure(1)
% hold off
% plot3(0,0,0,'o')
% hold on

% Makes some obstacles
[Obstacles oT oRot oTrans obsN] = makeObstaclesTest(2);

% Makes the  robot in its initial position   

startCon = [0 51 25 -2 -pi/2 0 0 0 0 0]';
% startCon = [0 20 20 -0.5 pi/2+pi/3 pi/6 -pi/6 pi/8 -pi/4 pi/6]';
linValues  = startCon(2:4); %[5 -2 -0.5]';     
thetaStart = startCon(5:10); % [pi/3 pi/6 -pi/6 pi/8 -pi/4 pi/6]';
[Manip, Man, fT, lT, lRot, lTrans, DH, LinLimits, JALimits] = makeRobot(linValues, thetaStart);
drawRobot(1,[0 1 0], linksN, Manip, lRot, lTrans);
drawRobot(2,[0 1 0], linksN, Manip, lRot, lTrans);

% Makes the robot in final position
goalPoint = [60 50 20]';
figure(2)
hold on 
plot3(goalPoint(1), goalPoint(2), goalPoint(3), 'r o' );
% goalCon = [0 60 40 -4 pi/3 -pi/5 -pi/7 pi/4 pi/4 pi/6]';
% finalPos   = goalCon(2:4); %[-5 -3 -4]';
% thetaFinal = goalCon(5:10); %[pi/3 -pi/5 -pi/7 pi/4 pi/4 pi/6];
% [Manip, Man, ffT, lfT, lfRot, lfTrans, DenHaf, LinLimits, JALimits] = makeRobot(finalPos, thetaFinal);
% drawRobot(1,[0 0 1], linksN, Manip, lfRot, lfTrans);
% drawRobot(2,[0 0 1], linksN, Manip, lfRot, lfTrans);

% [startNode, goalNode, newSamples, theComp]= connectStartGoal(startCon, goalCon, Samples, Components, Obstacles, linksN, obsN, oRot, oTrans);
[startNode, goalNode, newSamples, theComp]= connectStartGoalPoint(startCon, goalPoint, Samples, Components, Obstacles, linksN, obsN, oRot, oTrans,2);

shortPath =  getShortestPath(startNode, goalNode ,theComp.Node, theComp.NB)

[Obstacles oT oRot oTrans obsN] = makeObstaclesTest(2);

for i=1:length(shortPath)-1
    
    Config(1:10,1) = newSamples(1:10, shortPath(i) );
    Config(1:10,2) = newSamples(1:10, shortPath(i+1) );
    binDrawRobotABB(2, Config,1, 60*pi/180,linksN, obsN, Obstacles, oRot, oTrans);
end



% theta = [DH(5,1) DH(6,1) DH(7,1) DH(8,1) DH(9,1) DH(10,1)]';

% %% Probabilisitc road map
%  [Samples Components] = makeSamplesABB(LinLimits, JALimits, 60/180*pi, Obstacles, oRot, oTrans);

