% New PRM planner

 clear all;
figure(1)
hold off
plot3(0,0,0,'o')
hold on

% Makes some obstacles
[Obstacles oT oRot oTrans obsN] = makeObstaclesTest(1);

% Makes the robot in final position
% finalPos = [-5 -3 -4]';
% thetaFinal = [pi/3 -pi/5 -pi/7 pi/4 pi/4 pi/6];
% [Manip, Man, ffT, lfT, lfRot, lfTrans, DenHaf, LinLimits, JALimits] = makeRobot(finalPos, thetaFinal);
%    
% Makes the  robot in its initial position  
    %%%%%% Initial pose %%%%%%%
linValues = [5 -2 -0.5]';     
thetaStart = [pi/3 pi/6 -pi/6 pi/8 -pi/4 pi/6]';
[Manip, Man, fT, lT, lRot, lTrans, DH, LinLimits, JALimits] = makeRobot(linValues, thetaStart);

% theta = [DH(5,1) DH(6,1) DH(7,1) DH(8,1) DH(9,1) DH(10,1)]';

%% Probabilisitc road map
% w = [0 0.5 0.5 0.5 2 2 2 2 2 2];
w= [0 0.216 0.216 0.216 1.54 1.54 0.84 0.085 0.085 0.085];
step = 2;
% stepVec = [2 4 6 8 8];
teller = 1;

for i=1:5
    i   
    [coverage, TotalCoverage, sumQueriesConnection, TestResultConnection, TotalConnectionTime, TotalPathSearchTime, sampleTime, TotalComponents, binTypeVec, potTypeVec, binUsedWhenConnect, potUsedWhenConnect ] = makeBridgeSamplesTest_Pot_Nearest_k(75, LinLimits, JALimits,1, 5/180*pi,w, step, Obstacles, oRot, oTrans);

    bridgeFinalCoverage(i,:) = coverage
    bridgeFinalTotalCoverage(i,:) = TotalCoverage
    bridgeFinalSumQueriesConnection(i,:) = sumQueriesConnection
    bridgeFinalTestResultConnection(:,:,i) =  TestResultConnection
    bridgeFinalTotalConnectionTime(:,:,:,i) = TotalConnectionTime;
    bridgeFinaleTotalPathSearchTime(:,:,:,i)= TotalPathSearchTime;
    bridgeFinaleSampleTime(i,:) = sampleTime 
    bridgeFinalBinVec(i,:) = binTypeVec
    bridgeFinalPotVec(i,:) = potTypeVec
    bridgeFinalBinUsedConnect(:,:,i) = binUsedWhenConnect
    bridgeFinalPotUsedConnect(:,:,i) = potUsedWhenConnect
    
    
%     teller = teller + 1;
%     if teller ==6
%         teller =1;
%         step = stepVec(i/5);
%     end
end




