% New PRM planner

 clear all;
figure(1)
hold off
plot3(0,0,0,'o')
hold on

% Makes some obstacles
[Obstacles oT oRot oTrans obsN] = makeObstaclesTest(1);

% Makes the robot in final position
% finalPos = [-5 -3 -4]';
% thetaFinal = [pi/3 -pi/5 -pi/7 pi/4 pi/4 pi/6];
% [Manip, Man, ffT, lfT, lfRot, lfTrans, DenHaf, LinLimits, JALimits] = makeRobot(finalPos, thetaFinal);
%    
% Makes the  robot in its initial position  
    %%%%%% Initial pose %%%%%%%
linValues = [5 -2 -0.5]';     
thetaStart = [pi/3 pi/6 -pi/6 pi/8 -pi/4 pi/6]';
[Manip, Man, fT, lT, lRot, lTrans, DH, LinLimits, JALimits] = makeRobot(linValues, thetaStart);

% theta = [DH(5,1) DH(6,1) DH(7,1) DH(8,1) DH(9,1) DH(10,1)]';

%% Probabilisitc road map
w= [0 0.216 0.216 0.216 1.54 1.54 0.84 0.085 0.085 0.085];
step = 0.5;
stepVec = [2 4 6 8 8];
teller = 1;

for i=1:20
    i   
    [coverage, TotalCoverage, sumQueriesConnection, TestResultConnection, TotalConnectionTime, TotalPathSearchTime, sampleTime, TotalComponents ] = makeGaussianSamplesTest_Nearest_k(75, LinLimits, JALimits, 30/180*pi,w, step, Obstacles, oRot, oTrans);
    
    gaussianFinalCoverage(i,:) = coverage
    gaussianFinalTotalCoverage(i,:) = TotalCoverage
    gaussianFinalSumQueriesConnection(i,:) = sumQueriesConnection
    gaussianFinalTestResultConnection(:,:,i) =  TestResultConnection;
    gaussianFinalTotalConnectionTime(:,:,:,i) = TotalConnectionTime;
    gaussianFinaleTotalPathSearchTime(:,:,:,i)= TotalPathSearchTime;
    gaussianFinaleSampleTime(i,:) = sampleTime 
    gaussianFinalTotalComponents(i,:) = TotalComponents
    
    teller = teller + 1;
    if teller ==6
        teller =1;
        step = stepVec(i/5);
    end
end
