% Checks for collision between manipulator and Obstacles

function [inter] = collisionCheck(linksN, obsN, Manip, lRot, lTrans, Obstacles, oRot, oTrans )  

for l=1:linksN
    for o =1:obsN
        %Initializing
        vInit = [ 2 -6 3]';
        %Check for collision
        inter  = gjkInter(vInit, Manip(l,:), lRot(:,:,l), lTrans(:,:,l), Obstacles(o,:), oRot(:,:,o), oTrans(:,:,o) );
        if inter
            break;
        end
    end

    if inter
        break;
    end
end