%Script that shows a binary collision test

% Config(1:10,1) = [0 5 3 -2 pi/4 pi/6 pi/8 pi/3 0 0]';     %Start configuration
% Config(1:10,2) = [0 5 30 -8 -pi pi/6 -pi/8 pi/3 0 0]'; %Goal configuration

maxStep = 1;
maxAngle = 5*pi/180;
linksN = 10;

figure(1)
hold off 
plot3(0,0,0, 'o')
hold on

% Makes some obstacles
 [Obstacles oT oRot oTrans obsN] = makeAndDrawObstacles(1);

% Run the binary collision check
% [inter] = binCollisionCheckABB_New(Config,maxStep,maxAngle, linksN, obsN, Obstacles, oRot, oTrans)

% Config(1:10,1) = [0 40 23 -2 0 pi/6 pi/8 pi/3 0 0]';     %Start configuration
% Config(1:10,2) = [0 52 28 -7 pi/2 pi/6 -pi/8 pi/4 0 0]'; %Goal configuration

Config(1:10,1) = [0 65 23 6 pi pi/9 pi/8 pi/3 0 0]';     %Start configuration
Config(1:10,2) = [0 60 39 1 (pi-pi/4) pi/9 -pi/8 pi/4 0 0]'; %Goal configuration


% Run the binary collision check
[inter] = binCollisionCheckABB_New(Config,maxStep,maxAngle, linksN, obsN, Obstacles, oRot, oTrans)

