% Calcualting distance between two configurations a and b

function [distance] = configDist(aTheta, bTheta, w)
    distance = 0;    
if length(aTheta) == length(w) && length(aTheta) == length(bTheta)
    for i=1:length(aTheta)
        if i==8 || i==10
            distVec = [abs(aTheta(i)-bTheta(i))
                       aTheta(i)-bTheta(i)+2*pi
                       bTheta(i)-aTheta(i)+2*pi ];
            distance = distance + ( w(i)*min(distVec) )^2;
        else
            distance = distance + ( w(i)*abs( aTheta(i)-bTheta(i) ) )^2;
        end
    end
    distance = distance^0.5;
else
    error('w and depth are not of equal length');
end