
function [startNode, goalNode, Samples, theComp,successArray]= connectStartGoalBox(startCon, goalCon, Samples, Components,boxStruct, weightVec,  Obstacles, linksN, obsN, oRot, oTrans)

successArray = [0 0 0];
startConnected = false;
goalConnected = false;
% len = length(Components);
startNode = length(Samples)+1;
goalNode = startNode + 1;
Config(1:10,1) = startCon;
Config2(1:10,1)= goalCon;
% makeAndDrawRobot(startCon(2:4), startCon(5:10), 1, [ 0 1 0])
% makeAndDrawRobot(goalCon(2:4), goalCon(5:10), 1, [ 0 0 1])

% Finding the length of each component
% for i=1:len
%    compMat(i,1:2) = [length(Components(i).Node) i]; 
% end
% Sorting the components in descending order
% compMat = sortrows(compMat,[-1]); 

[ManipS, ManS, ffTStart, lfTS, lfRotS, lfTransS, DenHafS, LinLimitsS, JALimitsS] = makeRobot(startCon(2:4),startCon(5:10) );
[ManipG, ManG, ffTGoal, lfTG, lfRotG, lfTransG, DenHafG, LinLimitsG, JALimitsG] = makeRobot( goalCon(2:4) ,goalCon(5:10) );

[nbNodesStart] = getNBNodes(10,ffTStart(1:3,4,8), boxStruct)
[nbNodesGoal]  = getNBNodes(10,ffTGoal(1:3,4,8), boxStruct)

clear TempMatStart;
for teller = 1:length(nbNodesStart) %Computing distance to all nodes in  one component
    TempMatStart(teller,:) = [configDist(startCon, Samples(1:10,nbNodesStart(teller) ), weightVec ) nbNodesStart(teller)];% Components(i).Node(teller) ];
end
clear TempGoalStart;
for teller = 1:length(nbNodesGoal) %Computing distance to all nodes in  one component
    TempMatGoal(teller,:) = [configDist(startCon, Samples(1:10,nbNodesGoal(teller) ), weightVec ) nbNodesGoal(teller)];% Components(i).Node(teller) ];
end

% Sort the matrix with increasing distance
clear sortMatStart;
clear sortMatGoal;
sortMatStart = sortrows(TempMatStart);
sortMatGoal = sortrows(TempMatGoal);

for p = 1:length(nbNodesStart)
    j = sortMatStart(p,2); % j is the current node number
    tryConStart = Samples(1:10,j); % The configuration trying to connect to
    % Try connect start configuration
    %             if ~startConnected
    Config(1:10,2) = tryConStart;
    if ~binCollisionCheckABB( Config,1, 5*pi/180,linksN, obsN, Obstacles, oRot, oTrans);
        successArray(1) = 1;
        startConnected = true;
        for k=1:length(nbNodesGoal)
            g = sortMatGoal(k,2); % j is the current node number
            tryConGoal = Samples(1:10,g);
            % Try connect goal configuration
            %                         if ~goalConnected
            Config2(1:10,2) = tryConGoal;
            if ~binCollisionCheckABB( Config2,1, 5*pi/180,linksN, obsN, Obstacles, oRot, oTrans);
                successArray(2) = 1;
                goalConnected = true;
                if startConnected && goalConnected
                    if Samples(11,j) == Samples(11, g)

                        c = Samples(11, j);
                        Samples(1:10,startNode) = startCon;
                        Samples(11,startNode) = c;
                        disp(['Startnode kobles til nodee: ' int2str(j) ' som hrer til component: ' int2str(c)])
                        startDist = configDist(startCon,tryConStart, weightVec );
                        Components(c).NB(j, startNode ) = startDist;   %Adding the new distance
                        Components(c).NB(startNode, j ) = startDist;   %Adding the new distance
                        Components(c).Node = [Components(c).Node; startNode ]; %Adding the new node

                        %                 makeAndDrawRobot(tryConStart(2:4), tryConStart(5:10), 1, [ 0 1 0])
                        %                 makeAndDrawRobot(tryConStart(2:4)
                        %                 , tryConStart(5:10), 2, [ 0 1 0])                        

                        Samples(1:10,goalNode) = goalCon;
                        Samples(11,goalNode) = c;
                        %                     disp(['Sluttnode kobles til nodee: ' int2str(Components(i).Node(j)) ' som hrer til component: ' int2str(i)])
                        goalDist = configDist(goalCon,tryConGoal, weightVec );
                        Components(c).NB(goalNode, g ) = goalDist;  %Adding the new distance
                        Components(c).NB(g, goalNode ) = goalDist;  %Adding the new distance
                        Components(c).Node = [Components(c).Node; goalNode ]; %Adding the new node

                        %                 makeAndDrawRobot(tryConGoal(2:4), tryConGoal(5:10), 1, [ 0 0 1])
                        %                 makeAndDrawRobot(tryConGoal(2:4), tryConGoal(5:10), 2, [ 0 0 1])                      

                        theComp = Components(c);
                        successArray(3) = 1;
                        %                 disp('Succsessfully connected start and goal configuration')
                        return
                    else
                        successArray(3) = 0;
                        %                 dips('Start and goal node not connected to same configuration')
                        return
                    end
                end

            end

        end
    end
end % End for loop, done checking all nodes in component, try new component

if startConnected && ~goalConnected
            disp('Could only connect start configuration to this component . Try again')
    startConnected = false;
elseif ~startConnected && goalConnected
            disp('Could only connect goal configuration to this component. Try again')
    goalConnected = false;
end
%     end
% end

% if ~startConnected && ~goalConnected
%     theComp = 0;
% %     disp('Could not connect start and goal configuration')
% elseif ~startConnected
% %     disp('Could not connect start configuration')
% elseif ~goalConnected
% %     disp('Could not connect goal configuration')
% end
        
        