
function [startNode, goalNode, Samples, theComp,successArray]= connectStartGoal_pot(startCon, goalCon, Samples, Components, weightVec,  Obstacles, linksN, obsN, oRot, oTrans)

successArray = [0 0 0];
startConnected = false;
goalConnected = false;
len = length(Components);
startNode = length(Samples)+1;
goalNode = startNode + 1;
Config(1:10,1) = startCon;
Config2(1:10,1)= goalCon;
% makeAndDrawRobot(startCon(2:4), startCon(5:10), 1, [ 0 1 0])
% makeAndDrawRobot(goalCon(2:4), goalCon(5:10), 1, [ 0 0 1])

% Finding the length of each component
for i=1:len
   compMat(i,1:2) = [length(Components(i).Node) i]; 
end
% Sorting the components in descending order
compMat = sortrows(compMat,[-1]); 

% Try connect to a component
for k = 1:len
    i = compMat(k,2); % A little tweak...

%     if ~isempty(Components(i).Node)

        % Sorting the nodes in ascending order
        clear TempMat;
        for teller = 1:length(Components(i).Node) %Computing distance to all nodes in  one component
            TempMat(teller,:) = [configDist(startCon, Samples(1:10, Components(i).Node(teller) ), weightVec ) teller];% Components(i).Node(teller) ];
        end

        % Sort the matrix with increasing distance
        clear sortMat;
        sortMat = sortrows(TempMat);

        for p = 1:length(Components(i).Node )
            j = sortMat(p,2);

            if Components(i).Node(j)==0
                %             disp('Empty component')
                break;
            end

            tryCon = Samples(1:10,Components(i).Node(j)); % The configuration trying to connect to
            % Try connect start configuration
            if ~startConnected
                Config(1:10,2) = tryCon;
                if ~advanced_binCollisionCheckABB( Config,1, 5*pi/180,linksN, obsN, Obstacles, oRot, oTrans);
                    Samples(1:10,startNode) = startCon;
                    Samples(11,startNode) = i;
%                     disp(['Startnode kobles til nodee: ' int2str(Components(i).Node(j)) ' som hrer til component: ' int2str(i)])
                    startDist = configDist(startCon,tryCon, weightVec );
                    Components(i).NB(Components(i).Node(j), startNode ) = startDist;   %Adding the new distance
                    Components(i).NB(startNode, Components(i).Node(j) ) = startDist;   %Adding the new distance
                    Components(i).Node = [Components(i).Node; startNode ]; %Adding the new node

                    %                 makeAndDrawRobot(tryCon(2:4), tryCon(5:10), 1, [ 0 1 0])
                    %                 makeAndDrawRobot(tryCon(2:4), tryCon(5:10), 2, [ 0 1 0])
                    startConnected = true;
                    successArray(1) = 1;
                end
            end
            % Try connect goal configuration
            if ~goalConnected
                Config2(1:10,2) = tryCon;
                if ~advanced_binCollisionCheckABB( Config2,1, 5*pi/180,linksN, obsN, Obstacles, oRot, oTrans);
                    Samples(1:10,goalNode) = goalCon;
                    Samples(11,goalNode) = i;
%                     disp(['Sluttnode kobles til nodee: ' int2str(Components(i).Node(j)) ' som hrer til component: ' int2str(i)])
                    goalDist = configDist(goalCon,tryCon, weightVec );
                    Components(i).NB(goalNode, Components(i).Node(j) ) = goalDist;  %Adding the new distance
                    Components(i).NB(Components(i).Node(j), goalNode ) = goalDist;  %Adding the new distance
                    Components(i).Node = [Components(i).Node; goalNode ]; %Adding the new node

                    %                 makeAndDrawRobot(tryCon(2:4), tryCon(5:10), 1, [ 0 0 1])
                    %                 makeAndDrawRobot(tryCon(2:4), tryCon(5:10), 2, [ 0 0 1])
                    goalConnected = true;
                    successArray(2) = 1;
                end
            end



            if startConnected && goalConnected
                if Samples(11,startNode) == Samples(11, goalNode)
                    theComp = Components(i)
                    successArray(3) = 1;
                    %                 disp('Succsessfully connected start and goal configuration')
                    return
                else
                    successArray(3) = 0;
                    %                 dips('Start and goal node not connected to same configuration')
                    return
                end
            end
        end % End for loop, done checking all nodes in component, try new component

        if startConnected && ~goalConnected
            %         disp('Could only connect start configuration to this component . Try again')
            startConnected = false;
        elseif ~startConnected && goalConnected
            %         disp('Could only connect goal configuration to this component. Try again')
            goalConnected = false;
        end
%     end
end

if ~startConnected && ~goalConnected
    theComp = 0;
%     disp('Could not connect start and goal configuration')
elseif ~startConnected
%     disp('Could not connect start configuration')
elseif ~goalConnected
%     disp('Could not connect goal configuration')
end
        
        