% cross product

vec = [ -1 4 -5];
xyHyp = vec(1:2);
xzHyp = [vec(1) vec(3)];

figure(2)
hold off
plot3([0 5], [0 0], [0 0], 'r');
hold on
plot3([0 0], [0 5], [0 0], 'g');
plot3([0 0], [0 0], [0 5], 'b');
plot3([0 vec(1)], [0 vec(2)], [0 vec(3)], 'k');
axis([-5 5 -5 5 -5 5])

xyAngle = acos( vec(1)/norm(xyHyp) )*180/pi;
xzAngle = acos( vec(1)/norm(xzHyp) )*180/pi;

if vec(2) <0 
    xyAngle = -xyAngle;
end

if vec(3) < 0
    xzAngle = -xzAngle;
end

xyAngle
xzAngle








