% decrease the path length

function [path] = decreaseJointPath(path,weightVec, obsN, Obstacles, oRot, oTrans)

% preDecreaseJointPathLength = getPathLength(path,weightVec);
teller = 0;
probVec = makeProbVec(weightVec);

linksN = 10;
% maxStep = 2;
maxAngle = 2; 
maxTime = 10;
startTime = clock;
% joint = 5;
clear  testPath
for i=1:500
%     if etime(clock,startTime)>=maxTime
%         break;
%     end
    joint = randomJoint(probVec);
    if joint>4
        maxAngle = 15*pi/180;
    end
    
    pathLen = length( path(1,:) );
    
    for p=1:1000
        while 1
            a = ceil( rand()*pathLen );
            b = a + floor( rand()*( pathLen-a) );
            if a~=b && b>a
                break;
            end
        end

        testPath = path(:,a:b);
        step = ( path(joint,b)-path(joint,a) ) / (b-a);

        if step<maxAngle
            break;
        else
            disp('exceeded max angle');
        end

    end
    
    inter = false;    
    for j=2:length(testPath(1,:))

        testPath(joint,j) = testPath(joint,j-1) + step;
        
        [Manip, Man, fT, lT, lRot, lTrans, DH, LinLimits, JALimits] =...
            makeRobot( testPath(2:4,j), testPath(5:10,j) );
        inter = collisionCheckABB(linksN, obsN, Manip, lRot, lTrans, Obstacles, oRot, oTrans );
        if inter
            break
        end
    end
        
    if ~inter
        path(:,a:b) = testPath;
        teller = teller +1;        
        if mod(teller,10)==0
            currentPathLength(1,teller/10) = getPathLength(path,weightVec);
        end
        if teller==50
            currentPathLength
            break;
        end
%         disp('Joint path decreased')
    else
%         disp('Bad try')
    end
    
%     Config(:,1) = path(:,a);
%     Config(:,2) = path(:,b);   
%     if ~binCollisionCheckABB(Config,maxStep,maxAngle, linksN, obsN, Obstacles, oRot, oTrans)
%         
%         subPath = getSubPath(4, Config,1, 60*pi/180,linksN, obsN, Obstacles, oRot, oTrans);
%         path = [path(:,1:a-1) subPath path(:,b+1:pathLen) ];
% 
%         disp('Path decreased')
% 
%     else
%         disp('Bad try')
%     end

end

% postDecreaseJointPathLength = getPathLength(path,weightVec)