% decrease the path length

function [path] = decreasePath(path,weightVec, obsN, Obstacles, oRot, oTrans)

teller =0;

linksN = 10;
maxStep = 2;
maxAngle = 15/180*pi;

maxTime = 10;
startTime = clock;

for i=1:500
    if etime(clock,startTime)>=maxTime
        break;
    end
    pathLen = length( path(1,:) );
    
    while 1
    a = ceil( rand()*pathLen );
    b = a + floor( rand()*( pathLen-a) );
        if a~=b
            break;
        end
    end

    Config(:,1) = path(:,a);
    Config(:,2) = path(:,b);

    if ~binCollisionCheckABB(Config,maxStep,maxAngle, linksN, obsN, Obstacles, oRot, oTrans)
        
        subPath = getSubPath(4, Config,1, 60*pi/180,linksN, obsN, Obstacles, oRot, oTrans);
        path = [path(:,1:a-1) subPath path(:,b+1:pathLen) ];
        teller = teller +1;        
%         if mod(teller,10)==0
%             currentPathLength(1,teller/10) = getPathLength(path,weightVec);
%         end
%         if teller==100
%             currentPathLength
%             break;
%         end

%         disp('Path decreased')

    else
%         disp('Bad try')
    end

end