% decrease the path length

function [path] = decreasePathDeterministic(path,weightVec, obsN, Obstacles, oRot, oTrans)

teller =0;

linksN = 10;
maxStep = 2;
maxAngle = 15/180*pi;

radius =  floor(length( path(1,:) )/2);
minRadius = 0;%3;
startNext = 2;
maxTime = 20;
startTime = clock;

for i=1:5000
%     if etime(clock,startTime)>=maxTime
%         break;
%     end
    pathLen = length( path(1,:) );
    
    foundAB = false;
    for n=startNext:(pathLen-radius)
       if path(11,n)==1  && n>radius+1 
            a = n-radius;
            b = n+radius;
            startNext = b;
            foundAB = true;
            break
       end
    end
    if foundAB
%     if ~foundAB
%         startNext = 2;
%         radius = radius-1;
%         if radius ==minRadius
%             return
%         end
%         while 1
%             a = ceil( rand()*pathLen );
%             b = a + floor( rand()*( pathLen-a) );
%             if a~=b
%                 break;
%             end
%         end
%     end

    Config(1:10,1) = path(1:10,a);
    Config(1:10,2) = path(1:10,b);

    if ~binCollisionCheckABB(Config,maxStep,maxAngle, linksN, obsN, Obstacles, oRot, oTrans)
        
        subPath = getSubPath(4, Config,1, 60*pi/180,linksN, obsN, Obstacles, oRot, oTrans);
        subPath(11,1) = 1;
        subPath(11,length(subPath(1,:))) = 1;
        path = [path(:,1:a-1) subPath path(:,b+1:pathLen) ];
        teller = teller +1;        
%         if mod(teller,10)==0
%             currentPathLength(1,teller/10) = getPathLength(path,weightVec);
%         end
%         if teller==100
%             currentPathLength
%             break;
%         end

%         disp('Path decreased')

    else
%         disp('Bad try')
    end
    else
        startNext = 2;
        radius = radius-1;
        if radius ==minRadius
            disp('Min radius reached')
            return
        end
    end

end