function drawCylinder(fig, r, len, rot, trans)

    %  making a unit cylinder of radius r
n=20;    
[X, Y, Z] = cylinder(r,n);

    % align it around zero
len = len/2;
Z(1,1:n+1) = ones*len;
Z(2,1:n+1) = -ones*len;
    
    %Specify the cylinder color
Color(1, 1:n+1) = ones*1;
Color(2, 1:n+1) = ones*2;

    % rotate and translate the cylinder
big = size(X);
for i=1:big(1)
        for j=1:big(2)
            
            vec = rot*[X(i,j) Y(i,j) Z(i,j)]' + trans;
            
        X1(i,j) = vec(1);
        Y1(i,j) = vec(2); 
        Z1(i,j) = vec(3); 
        end
          
end

t = 0:2*pi/n:2*pi;
x1= r*cos(t);
y1= r*sin(t);
z1( 1:length(x1) )= ones*len;

x2= r*cos(t);
y2= r*sin(t);
z2(1:length(x2))= -ones*len;

for i = 1:length(x1)
    vecDisc= rot*[x1(i) y1(i) z1(i)]' + trans;
    
    x1(i) = vecDisc(1);
    y1(i) = vecDisc(2);
    z1(i) = vecDisc(3);
    
    vecDisc2= rot*[x2(i) y2(i) z2(i)]' + trans;
    
    x2(i) = vecDisc2(1);
    y2(i) = vecDisc2(2);
    z2(i) = vecDisc2(3);
end
    
% x2= sin(t);
% y2= cos(t);
% z2(1:length(x2))= zeros;

  %Specify the cylinder color
colorDisc(1, 1:length(x1)) = ones*1;

 figure(fig)
% % axis([-20 20 -20 20 -20 20]);      
hold on
surf(X1, Y1, Z1, Color );
fill3(x1,y1,z1,colorDisc)
fill3(x2,y2,z2,colorDisc)

% % hold off