% Draws the two vertical bars of the gantry crane

function drawGantryCrane(fig,farge, ffT, x)

Gant(:,:,1) = ffT(:,:,2);
Gant(:,:,2) = ffT(:,:,2);

Gant(1:3,4,1) = [x 2 34/2]';
Gant(1:3,4,2) = [x 85 34/2]';

init(1:3,1) = Gant(1:3,4,1);
init(1:3,2) = Gant(1:3,4,1);
init(1:3,3) = Gant(1:3,4,1);

goal = init + [5 0 0
               0 5 0
               0 0 5];

Gantry= 0.5*[34.00 2.00 2.00];

[xlink1 ylink1 zlink1] = linkTransf( Gantry(1,1), Gantry(1,2), Gantry(1,3) , Gant(1:3,1:3,1), Gant(1:3,4,1) );
[xlink2 ylink2 zlink2] = linkTransf( Gantry(1,1), Gantry(1,2), Gantry(1,3) , Gant(1:3,1:3,2), Gant(1:3,4,2) );
    figure(fig)
    hold on
    patch(xlink1, ylink1, zlink1, farge);
    patch(xlink2, ylink2, zlink2, farge);
    
%     plot3([init(1,1) goal(1,1)],[init(2,1) goal(2,1)],[init(3,1) goal(3,1)],' r');
%     plot3([init(1,2) goal(1,2)],[init(2,2) goal(2,2)],[init(3,2) goal(3,2)],'g');
%     plot3([init(1,3) goal(1,3)],[init(2,3) goal(2,3)],[init(3,3) goal(3,3)],'k');
%      plot3(init(1,3), init(2,3),init(3,3) ,'b o');

