function [inter dist v r obs] = gjkSphere(v,R, rRot, rTrans, Obs, obsRot, obsTrans)

W(1:4,1:3,1) = zeros; 
wR   = supportPoint(-v, R(:,:,1), rRot,rTrans);   
wObs = supPointSphere(v, Obs(1,1,1), obsRot, obsTrans);  
w = wR-wObs;
WR(1,:)=wR'; WObs(1,:) = wObs'; %Keeping each objects support point. 
W(1,:,1) = w' ;
v=w;
vectors(1,:)=v';
freeIndex = 2;
maxIt = 20;
repetition = false;
inter = false;
 
    for i=2:maxIt %Use for loop to avoid infinte loop
        i
      
        [v Wmatrix lambda freeIndex] = shortDist(W(:,:,i-1),1);    
        Wmatrix;
      
         wR   = supportPoint(-v, R(:,:,1), rRot,rTrans);   
         wObs = supPointSphere(v, Obs(1,1,1), obsRot, obsTrans);  
         w = wR-wObs;        
         WR(i,:)=wR'; WObs(i,:) = wObs'; %Keeping each objects support point.
         
%          figure(6)
%          hold on
%          plot3([v(1) 0], [v(2) 0], [v(3) 0],'r');
%          plot3(v(1), v(2), v(3));
%          plot3(w(1),w(2),w(3), 'k h');
         prodOne = v'*w
         termi = norm(v)^2 - prodOne 
         prod(i) = termi;
         
              %Check for collision, if there not exists a separating axis
        if i>(maxIt-3)
            if prodOne < -0.00000001 
                dist = 0.001;
                disp(' **********INTERSECTION***********************');
                inter = true;
                break;
                %error(' INTERSECTION!!!')
            end
        end 
        
        %Checks if the answer is alternateing.
        if i>(maxIt-2) && prodOne >0            
            
            if repeatCheck2(w,W(:,:,i-1))
                repetition = true;
            elseif repeatCheck2(w,W(:,:,i-2))
                repetition = true;
            elseif repeatCheck2(w,W(:,:,i-3))
                repetition = true;
            elseif repeatCheck2(w,W(:,:,i-4))
                repetition = true;
            elseif repeatCheck2(w,W(:,:,i-5)) %this should be enough
                repetition = true;    
            end
            
            if repetition            
                disp('Repeating answer')
                repetition = true;
                dist=norm(v);
                break;
            end
        end
                 
        W(:,:,i) = Wmatrix;          
        W(freeIndex,:,i) = w';
        
           % Checking for termination or repetition exists    
           %termi = v'*w
           %limten = norm(v)^2 + w'*(-v) ;
        if  termi < 0.001 && prodOne > -0.0001             
            dist=norm(v);
            break;
        end      
        
        % Check that a closest distance is found 
        if i == maxIt
             dist=norm(v);
            inter = true;
            disp(' could not find closest distance' )
                break;
            %error(' could not find closest distance' )
        end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% PLOT %%%%%%%%%%%%%%%%%%%%%%%%       
%         figure(5)
%           hold on 
%           plot3(w(1), w(2), w(3),'r x' )
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
    end

    % Converting point from Minkowski sum to point on robot and obstacle
    
[Wl Ww Wd] = size(W);
[WRl WRw WRd] =size(WR);
       
 for j=1:length(lambda)   
    for i=1:WRl
        wTemp = WR(i,:)-WObs(i,:);
        if any((WR(i,:)-WObs(i,:)-W(j,:,Wd)))==0     
            rPoint(j,:)  = WR(i,:);
            obsPoint(j,:)= WObs(i,:);           
        end
    end
 end   
    r=0;
    obs=0;
    for i=1:length(lambda)
        r   = r   + lambda(i)*rPoint(i,:);
        obs = obs + lambda(i)*obsPoint(i,:);
    end
    
    % Draw the closestp point if repeating
    if repetition
    figure(1)
    hold on       
    plot3([r(1) obs(1)],[r(2) obs(2)],[r(3) obs(3)],'- h b');
    end
    
    
    