%Computing the transposed Jacobian from base to joint 3

function [J] = jacobianT03(DH)



s1 = sin( DH(1,1) );
s2 = sin( DH(2,1) );
%s3 = sin( DH(3,1) );
c1 = cos( DH(1,1) );
c2 = cos( DH(2,1) );
%c3 = cos( DH(3,1) );
s23 = sin( DH(2,1) + DH(3,1) );
c23 = cos( DH(2,1) + DH(3,1) );

a2 = DH(2,3);
a3 = DH(3,3);

J =[ -s1*(a2*c2* + a3*c23 )   c1*( a2*c2  + a3*c23 )  0
     -c1*( a2*s2 + a3*s23 )  -s1*( a2*s2  + a3*s23 )  a2*c2 + a3*c23
     -c1*a3*s23              -s1*a3*s23               a3*c23                     ];
 
 %s1^2*(a2*c2 + a3*c23) + c1^2*(a2*c2 + a3*c23)
 %s1^2*a3*c23 + c1^2+a3*c23 