
function [Manip, Man, ffT, lfT, lfRot, lfTrans] = linRob(x, y, z, theta)

DenHaf = [  0         0       0   -pi/2
          -pi/2       y      30   -pi/2
          -pi/2       x       0   -pi/2
          pi/2       -1.20+z  0    pi
           theta(1)       6.15  1.00  -pi/2
           theta(2)-pi/2  0.00  7.05   0
           theta(3)       0.00  1.35  -pi/2
           theta(4)       7.55  0.00  pi/2]; 
%thetaFinal = [DenHaf(1,1) DenHaf(2,1) DenHaf(3,1) DenHaf(4,1) ]'

Manip = 0.5*[ 0.10 0.10 0.10    
              2.00 2.00 40.0
              2.40 2.40 2.40
              1.50 1.50 8.00
              4.10 6.15 4.10 
              7.05 1.00 1.00
              2.00 2.00 3.60
              1.00 9.35 1.00  ];
          
Man = 0.5*[ 0.00 0.00 0.00
            0.00 0.00 0.00
            0.00 0.00 0.00
            0.00 0.00 8.00
            0.00 6.15 0.00
            7.05 0.00 0.00
            0.00 0.00 0.00 %3.60
            0.00 9.35 0.00  ];         

  % Making transformation matrices for the final joint frames
[ffT, ffRot, ffTrans ] = dh(DenHaf);

% Making transformation matrices for the final links
[lfT, lfRot, lfTrans ] = dhLinkABBSystem(ffT,Manip,Man);

[linksN notInUse1] = size(Manip);
% [obsN notInUse2] = size(Obstacles);

figure(4)
plot3(ffT(1,4,3), ffT(2,4,3), ffT(3,4,3),'r o')
hold on

drawRobot(4, linksN, Manip, lfRot, lfTrans)

axis([-20 20 -20 20 0 40]);
hold off