
function makeAndDrawRobotLimitsNew(linValues, theta,joint, jLimits,jo)
fig =1;
initialTheta = theta;
figure(fig)
hold off
plot3(0,0,0,'o')
hold on

for i=1:3
    theta = initialTheta;
    if i==1
        color = [1 0 0];        
        theta(joint) = theta(joint) -theta(jo);
        RSangles (1) = 180/pi*theta(joint);
        
        MLangles (1) = 180/pi*theta(joint);
    elseif i==2
        color =[0 1 0];
%         theta(joint) = theta(joint) + pi/180*jLimits(1)  -theta(jo);
        theta(joint) = pi/180*jLimits(1)  -theta(jo);
        RSangles (2) = 180/pi*theta(joint)+180/pi*theta(jo);
        MLangles (2) = 180/pi*theta(joint);
    else
        color = [0 0 1];
%         theta(joint) = theta(joint) + pi/180*jLimits(2) -theta(jo); 
        theta(joint) = pi/180*jLimits(2) -theta(jo); 
        RSangles (3) = 180/pi*theta(joint)+180/pi*theta(jo);
        MLangles (3) = 180/pi*theta(joint);
    end


LinLimits = [ 0  80
              0 60
             -8-6.30   0-6.30] ;
% Specify the joint angle lmitis

JALimits = pi/180* [-180    180
                    -100-90 110-90
                    -60     65
                    -200    200
                    -120    120
                    -400    400];

DenHaf = [ pi/2           34.30           13.50   pi/2
           pi/2      linValues(1)          0.00   pi/2
           pi/2      linValues(2)          0.00   pi/2
           0.00      linValues(3)-6.30-8     0.00   pi
           theta(1)       6.15   1.00  -pi/2
           theta(2)-pi/2  0.00   7.05   0
           theta(3)       0.00   1.35  -pi/2
           theta(4)       7.55   0.00   pi/2%]; 
           theta(5)       0.00   0.00  -pi/2
           theta(6)       0.85   0.00   0   ];
%thetaFinal = [DenHaf(1,1) DenHaf(2,1) DenHaf(3,1) DenHaf(4,1) ]'
% linValuesFinal = [DenHaf(2,2) DenHaf(3,2) DenHaf(4,2)]';
% thetaFinal = [DenHaf(5,1) DenHaf(6,1) DenHaf(7,1) DenHaf(8,1) DenHaf(9,1) DenHaf(10,1) ];
% [notInUse1, notInUSe2 ]=limitCheckError(linValuesFinal, thetaFinal, LinLimits, JALimits);

Manip = 0.5*[ 0.10  0.10   1.00   
              4.00  4.00  87.0
              6.00  6.00  12.60 %12.60  6.00   6.00
              3.00  3.00  22.60
              4.10  6.15   4.10 %
              7.05  1.00   1.00
              2.00  2.00   3.60
              1.00  9.35   1.00
              0.00  0.00   0.00
              0.60  0.60   0.85];
          
Man = 0.5*[ 0.00 0.00 0.00
            0.00 0.00 27.00-87.00
            0.00 0.00 0.00
            0.00 0.00 22.60 %12.60%
            0.00 6.15 0.00 %
            7.05 0.00 0.00
            1.00 0.00 0.00 %3.60
            0.00 9.35 0.00  
            0.00 0.00 0.00
            0.00 0.00 0.85 ];         

  % Making transformation matrices for the final joint frames
[ffT, ffRot, ffTrans ] = dh(DenHaf);

% for i =1:length(DenHaf)
%    plot3(ffT(1,4,i), ffT(2,4,i), ffT(3,4,i),'o b'); 
% end


  % Making transformation matrices for the final links
[lfT, lfRot, lfTrans ] = dhLinkABBSystem(ffT,Manip,Man);

[linksN notInUse1] = size(Manip);

drawRobot(fig, color, linksN, Manip, lfRot, lfTrans)

%  drawGantryCrane(fig, ffT, linValues(1))

axis([0 100 0 100 0 100]);
end
RSangles
MLangles