function [X1, Y1, Z1] = makeCylinder(r, len, rot, trans)

% % Obstacles = [2 4];   
% % r = 2.5;
% % len = 40;
% %                
% % ObsMat= [  0    0    0     5   2 0];
% % 
% %     %Making transformation Matrices for the obstacles
% % [oT oRot oTrans] = obsTransformation(ObsMat);
% % 
% % rot =oRot;
% % trans=oTrans;

    %  making a unit cylinder of radius r
n=10;    
[X, Y, Z] = cylinder(r,n);

    % align it around zero
len = len/2;
Z(1,1:n+1) = ones*len;
Z(2,1:n+1) = -ones*len;
    
    %Specify the cylinder color
Color(1, 1:n+1) = ones*1;
Color(2, 1:n+1) = ones*2;

    % rotate and translate the cylinder
big = size(X);
for i=1:big(1)
        for j=1:big(2)
            
            vec = rot*[X(i,j) Y(i,j) Z(i,j)]' + trans;
            
        X1(i,j) = vec(1);
        Y1(i,j) = vec(2); 
        Z1(i,j) = vec(3); 
        end
          
end
 figure(3)
% % axis([-20 20 -20 20 -20 20]);      
hold on
surf(X1, Y1, Z1, Color );
% % hold off