% make a probability vector using the weights

function probVec = makeProbVec(weightVec)

lenW = length(weightVec);

probVec(1,1:lenW) = 1:lenW;
vec(1:lenW,1) = ones;

sumWeight = weightVec*vec;

for i=1:lenW
   if i>1 
        probVec(2,i) = probVec(2,i-1) + weightVec(1,i)/sumWeight ;
   else
       probVec(2,i) =  weightVec(1,i)/sumWeight; 
   end
end