
function [Manip, Man, ffT, lfT, lfRot, lfTrans, DenHaf, linValues, theta] = makeRandomGridRobotConfig(LinLimits, JALimits)

% LinLimits = [ 0  80
%               0 60
%              -8-6.30   0-6.30] ;
% % Specify the joint angle lmitis
% 
% JALimits = pi/180* [-180    180
%                     -100-90 110-90
%                     -60     65
%                     -200    200
%                     -120    120
%                     -400    400];
             
linValues(1,1) = ( rand()* (LinLimits(1,2)-LinLimits(1,1)) ) + LinLimits(1,1);
linValues(2,1) = ( rand()* (LinLimits(2,2)-LinLimits(2,1)) ) + LinLimits(2,1)
linValues(3,1) = rand()*8;  %( abs(LinLimits(3,1)+6.30)+abs(LinLimits(3,2)+6.30))*rand() + (LinLimits(3,1)+6.30);

theta(1,1) = (abs(JALimits(1,1))+abs(JALimits(1,2))           )*rand() + JALimits(1,1);
theta(2,1) = (abs(JALimits(2,1)+pi/2)+abs(JALimits(2,2)+pi/2) )*rand() + JALimits(2,1)+pi/2 ; 
theta(3,1) = (abs(JALimits(3,1))+abs(JALimits(3,2)) )*rand() + JALimits(3,1);
theta(4,1) = (abs(JALimits(4,1))+abs(JALimits(4,2))           )*rand() + JALimits(4,1) ;
theta(5,1) = (abs(JALimits(5,1))+abs(JALimits(5,2))           )*rand() + JALimits(5,1) ;
theta(6,1) = (abs(JALimits(6,1))+abs(JALimits(6,2))           )*rand() + JALimits(6,1) ;

DenHaf = [ pi/2           34.30           13.50   pi/2
           pi/2      linValues(1)          0.00   pi/2
           pi/2      linValues(2)          0.00   pi/2
           0.00      linValues(3)-6.30-8     0.00   pi
           theta(1)       6.15   1.00  -pi/2
           theta(2)-pi/2  0.00   7.05   0
           theta(3)       0.00   1.35  -pi/2
           theta(4)       7.55   0.00   pi/2%]; 
           theta(5)       0.00   0.00  -pi/2
           theta(6)       0.85   0.00   0   ];

% linValuesFinal = [DenHaf(2,2) DenHaf(3,2) DenHaf(4,2)]';
% thetaFinal = [DenHaf(5,1) DenHaf(6,1) DenHaf(7,1) DenHaf(8,1) DenHaf(9,1) DenHaf(10,1) ];
% [notInUse1, notInUSe2 ]=limitCheckError(linValuesFinal, thetaFinal, LinLimits, JALimits);

Manip = 0.5*[ 0.10  0.10   1.00   
              4.00  4.00  87.0
              6.00  6.00  12.60 %12.60  6.00   6.00
              3.00  3.00  22.60
              4.10  6.15   4.10 %
              7.05  1.00   1.00
              2.00  2.00   3.60
              1.00  9.35   1.00
              0.00  0.00   0.00
              0.60  0.60   0.85];
          
Man = 0.5*[ 0.00 0.00 0.00
            0.00 0.00 27.00-87.00
            0.00 0.00 0.00
            0.00 0.00 22.60 %12.60%
            0.00 6.15 0.00 %
            7.05 0.00 0.00
            1.00 0.00 0.00 %3.60
            0.00 9.35 0.00  
            0.00 0.00 0.00
            0.00 0.00 0.85 ];         
  % Making transformation matrices for the final joint frames
[ffT, ffRot, ffTrans ] = dh(DenHaf);

  % Making transformation matrices for the final links
[lfT, lfRot, lfTrans ] = dhLinkABBSystem(ffT,Manip,Man);

%  [linksN notInUse1] = size(Manip);

%   drawRobot(1,[1 0 0], linksN, Manip, lfRot, lfTrans)

%  drawGantryCrane(1, ffT, linValues(2))

