% Connects the node to a component

% function [success Samples comp emptyComp] = mergeComponents(con, c,ind, Samples, comp, sortMat, emptyComp)
function [success Samples comp mergedComp]= mergeComponentsInterMed(Samples, comp, nbConfig, diffCompNumber, connectCompNumber, connectToNode, connectDist, mergedComp)
         nbNode = length(Samples)+1                         

success = false;

    if size(comp(diffCompNumber).NB)>=size(comp(connectCompNumber).NB) %Merge the smallest component into the biggest
        disp('Merge two components together....method A')
        disp(['kobler component ' int2str(connectCompNumber) ' til component ' int2str(diffCompNumber)...
        ' mellom node ' int2str(connectToNode) ' og node ' int2str(nbNode)] );     
        
        Samples(1:10,nbNode) = nbConfig;
        Samples(11,nbNode) = diffCompNumber;
    
        len = length(comp(connectCompNumber).NB);
        comp(diffCompNumber).NB(1:len,1:len)= comp(diffCompNumber).NB(1:len,1:len)+comp(connectCompNumber).NB;
        comp(diffCompNumber).NB(nbNode, connectToNode) = connectDist;
        comp(diffCompNumber).NB(connectToNode, nbNode) = connectDist;
       
        for teller=1:length(comp(connectCompNumber).Node)
            Samples(11,comp(connectCompNumber).Node(teller)) = diffCompNumber;             
        end
        % Overfrer de nye nodene
        comp(diffCompNumber).Node = [comp(diffCompNumber).Node ; comp(connectCompNumber).Node; nbNode]; 
        
%         distanceNB = configDist(difficultConfig,nbConfig,w);                        
%         comp(diffCompNumber).NB(difficultSample,nbNode) = distanceNB;
%         comp(diffCompNumber).NB(nbNode, difficultSample) = distanceNB;
%         
        % "clear" the current component
        comp(connectCompNumber).Node = [];  
        comp(connectCompNumber).NB   = [];
        if isempty(mergedComp);
            mergedComp(1) = connectCompNumber;
        else
            mergedComp = sort([mergedComp connectCompNumber]);
        end
        success = true;
        %return; % Done connecting to this component
        
    else
        disp('Merge two components together....method B')
        disp(['kobler component ' int2str(diffCompNumber) ' til component ' int2str(connectCompNumber)...
        ' mellom node ' int2str(nbNode) ' og node ' int2str(connectToNode)] );     
        
        Samples(1:10,nbNode) = nbConfig;
        Samples(11,nbNode) = connectCompNumber;
        
        len = length(comp(diffCompNumber).NB);            
        
        comp(connectCompNumber).NB(1:len,1:len)= comp(connectCompNumber).NB(1:len,1:len) + comp(diffCompNumber).NB;
        comp(connectCompNumber).NB(nbNode,connectToNode) = connectDist;
        comp(connectCompNumber).NB(connectToNode,nbNode) = connectDist;
                
        for teller=1:length( comp(diffCompNumber).Node )
            Samples(11,comp(diffCompNumber).Node(teller)) = connectCompNumber;             
        end
        % Overfre de nye nodene
        comp(connectCompNumber).Node = [comp(connectCompNumber).Node ; comp(diffCompNumber).Node; nbNode];
        
%         distanceNB = configDist(difficultConfig,nbConfig,w);                        
%         comp(connectCompNumber).NB(difficultSample,nbNode) = distanceNB;
%         comp(connectCompNumber).NB(nbNode, difficultSample) = distanceNB;
%         
        % "clear" the current component
        comp(diffCompNumber).Node = [];  
        comp(diffCompNumber).NB   = [];
        if isempty(mergedComp)
            mergedComp(1) = diffCompNumber;
        else
            mergedComp = sort([mergedComp diffCompNumber ]);
        end
        success = true;
    end  
    

