% moves a random direction

function [newConfig] = moveRandDir(step,w,conf, LinLimits, JALimits)

vec = step*rand(10,1);
vec(1) = 0;

for i =2:length(vec)
    joint(i) = vec(i)*1/w(i); 
end

newConfig = conf + joint';

% Checks that newConfig does not exceed joint limits
[linValues, theta]=limitCheck(newConfig(2:4), newConfig(5:10), LinLimits, JALimits);

newConfig(2:4) = linValues;
newConfig(5:10)= theta;