% Makes obstacles

function [Obstacles oT oRot oTrans] makeObstacels()

Obstacles = [1 14
             2 8
             1 10];
    
ObsMat= [pi/5     pi/9    0     6    0    20
         0     pi/8    0     10   0   8%];
         0     pi/3    pi/4      0   7   10];

numObs =size(Obstacles);

    %Making transformation Matrices for the obstacles
[oT oRot oTrans] = obsTransformation(ObsMat);

[obsN notInUse2] = size(Obstacles);

    % Drawing the Obstacles
    for i=1:obsN
        drawCylinder(1, Obstacles(i,1), Obstacles(i,2), oRot(:,:,i), oTrans(:,:,i) );
    end
