
% function robotConfigTest(linValues, theta)
function robotConfigTest()

% TestConfigs = [0 52 28 -8 pi/2 20*pi/180 -pi/4 0 0 0]';
% TestConfigs = [0 51 25 -2 -pi/2 0 0 0 0 0]';
TestConfigs = [0 40 40 -4 pi/4 0 0 0 0 0]';
linValues = TestConfigs(2:4);
% theta = [-pi/2 0 -pi/4 0 0 0];
theta = TestConfigs(5:10); %(pi/180)*[-90 20 -45 0 0 0];

[Obstacles oT oRot oTrans obsN] = makeAndDrawObstacles(5);

fig = 5;
color = [1 0 0];
LinLimits = [ 0      80
              0      60
             -8-6.3  0-6.3] ;
% Specify the joint angle lmitis, note: converted directly to radians

JALimits = pi/180* [-180    180
                    -64-90  60-90
                    -101+45    34+45
                    -200    200
                    -120    120
                    -360    360];

% JALimits = pi/180* [-180    180
%                     -100-90 110-90
%                     -65      60
%                     -180    180
%                     -360    360
%                     -120    120
%                     -360    360];

DenHa = [  pi/2           34.30           13.50   pi/2
           pi/2      linValues(1)          0.00   pi/2
           pi/2      linValues(2)          0.00   pi/2
           0.00      linValues(3)-6.30     0.00   pi
           theta(1)       6.15   1.00  -pi/2
           theta(2)-pi/2  0.00   7.05   0
           theta(3)+pi/4  0.00   1.35  -pi/2
           theta(4)       7.55   0.00   pi/2%]; 
           theta(5)       0.00   0.00  -pi/2
           theta(6)       0.85   0.00   0   ];
linValuesFinal = [DenHa(2,2) DenHa(3,2) DenHa(4,2)]';
thetaFinal = [DenHa(5,1) DenHa(6,1) DenHa(7,1) DenHa(8,1) DenHa(9,1) DenHa(10,1) ];

Manip = 0.5*[ 0.10  0.10   1.00   
              4.00  4.00  87.0
              6.00  6.00  12.60 %12.60  6.00   6.00
              3.00  3.00  22.60
              4.10  6.15   4.10 %
              7.05  1.00   1.00
              2.00  2.00   3.60
              1.00  9.35   1.00
              0.00  0.00   0.00
              0.60  0.60   0.85];
          
Man = 0.5*[ 0.00 0.00 0.00
            0.00 0.00 27.00-87.00
            0.00 0.00 0.00
            0.00 0.00 22.60 %12.60%
            0.00 6.15 0.00 %
            7.05 0.00 0.00
            1.00 0.00 0.00 %3.60
            0.00 9.35 0.00  
            0.00 0.00 0.00
            0.00 0.00 0.85 ];         

  % Making transformation matrices for the final joint frames
[ffT, ffRot, ffTrans ] = dh(DenHa);

% for i =1:length(DenHa)
%    plot3(ffT(1,4,i), ffT(2,4,i), ffT(3,4,i),'o b'); 
% end

  % Making transformation matrices for the final links
[lfT, lfRot, lfTrans ] = dhLinkABBSystem(ffT,Manip,Man);

[notInUse1, notInUSe2 ]=limitCheckError(linValuesFinal, thetaFinal, LinLimits, JALimits);

[linksN notInUse3] = size(Manip);

drawRobot(fig, color, linksN, Manip, lfRot, lfTrans)

%  drawGantryCrane(fig, ffT, linValues(1))

axis([0 100 0 100 0 100]);
% hold off