% Finding the shortest distance to the origin from the points set W

function [v W lambda freeIndex] = shortDist(W,set) 
%     y12 = W(1,:,set);
%     y22 = W(2,:,set);
%     y32 = W(3,:,set);
%     y42 = W(4,:,set);

% This function is not made in the most cost efficient way.
% First priority is to get everything to work orderly
 
 freeIndex = 0;
 IsComp = [0];

 vertices = 0;
 hoi = 0;
 for j=1:length( W(:,1,set) )
    if any( W(j,:,set) )
        W(j,:,set);
        vertices = vertices+1;
        I(vertices) = j;    
    end
 end

if vertices==4
   
    y1 = W(1,:,set) ;
    y2 = W(2,:,set) ;
    y3 = W(3,:,set) ;
    y4 = W(4,:,set) ;
    
    A1= [    1     (y2-y1)*y1' (y3-y1)*y1' (y4-y1)*y1'  
         1     (y2-y1)*y2' (y3-y1)*y2' (y4-y1)*y2'
         1     (y2-y1)*y3' (y3-y1)*y3' (y4-y1)*y3'
         1     (y2-y1)*y4' (y3-y1)*y4' (y4-y1)*y4'];  

     A2=A1;
     A3=A1;
     A4=A1;
 
  A1(1,:) = [1 0 0 0];
  A2(2,:) = [1 0 0 0];
  A3(3,:) = [1 0 0 0];
  A4(4,:) = [1 0 0 0];
  detA(1) = det(A1);
  detA(2) = det(A2);
  detA(3) = det(A3);
  detA(4) = det(A4);
  deltaA = detA(1)+detA(2)+detA(3)+detA(4);
  
  l1 = detA(1)/deltaA;
  l2 = detA(2)/deltaA;
  l3 = detA(3)/deltaA;
  l4 = detA(4)/deltaA;

v = l1*y1 + l2*y2 + l3*y3 + l4*y4;
dist = norm(v)    ;

if l1>0 && l2>0 && l3>0 && l4>0        
        if (l1+l2+l3+l4)>0
            delta=0;
            k = 1;
            for i=length(I)
                delta = delta + detA(i) * W(i,:,set)*W(k,:,set)' ; 
            end
            
            if delta<=0
                W(1,:,set) = y1;
                W(2,:,set) = y2;
                W(3,:,set) = y3;
                W(4,:,set) = y4;
                vertices = 0;
                freeIndex = 5;
                lambda = [l1 l2 l3 l4];                
                W;
                v=v';
            end          
        end       
    end

    vertices = 3;
    
end
 
if vertices==3  
    
   for i=1:length(I)
        if i==length(I)
            y1 = W(I(i) ,:,set);
            y2 = W(I(1) ,:,set);
            y3 = W(I(2) ,:,set);
            Is =[1 2 I(i)];
        elseif i == ( length(I)-1 )
            y1 = W(I(i) ,:,set);
            y2 = W(I(i+1) ,:,set);
            y3 = W(I(1) ,:,set);
            Is =[ 2 I(i) I(i+1) ];
            
        else
            y1 = W(I(i)   ,:,set);
            y2 = W(I(i+1) ,:,set);
            y3 = W(I(i+2) ,:,set);
            Is = [ I(i) I(i+1) I(i+2) ];
        end
        hoi = 0;
        for p=1:length(I)
            if any( y1-W(p,:,set) )~=0 && any( y2-W(p,:,set)~=0 ) && any( y3-W(p,:,set)~=0 ) 
                hoi=hoi + 1;
                IsComp(hoi) = p;
            end
        end
    
    
A1= [1 (y2-y1)*y1' (y3-y1)*y1' 
     1 (y2-y1)*y2' (y3-y1)*y2'
     1 (y2-y1)*y3' (y3-y1)*y3' ]; 

A2=A1;
A3=A1;
 
  A1(1,:) = [1 0 0];
  A2(2,:) = [1 0 0];
  A3(3,:) = [1 0 0];
  detA(1) = det(A1);
  detA(2) = det(A2);
  detA(3) = det(A3);
  deltaA = detA(1) + detA(2) + detA(3);
  
  l1 = detA(1)/deltaA;
  l2 = detA(2)/deltaA;
  l3 = detA(3)/deltaA;

v = l1*y1 + l2*y2 + l3*y3;
dist = norm(v);  
    
    if l1>0 && l2>0 && l3>0        
        if (l1+l2+l3)>0
            if any(IsComp)==1       
                delta=0;
                k = min(Is);
                deltaJ = false;
                
                
                for j=1:length(IsComp)
                    for p=1:length(Is)
                        delta = delta + detA(p) * ( (W(Is(p),:,set) * W(Is(1),:,set)') -( W(Is(p),:,set)*W(IsComp(j),:,set)' ) );
                    end
                    if delta<=0
                        deltaJ = true;
                    else
                        deltaJ = false;
                    end
                end
            
            
                if deltaJ==true
                    W(1,:,set) = y1;
                    W(2,:,set) = y2;
                    W(3,:,set) = y3;
                    W(4,:,set) = [0 0 0];
                    vertices = 0;
                    freeIndex = 4;
                    lambda = [l1 l2 l3];
                    W;
                    v=v';
                    break;
                end
             else
                 W(1,:,set) = y1;
                 W(2,:,set) = y2;
                 W(3,:,set) = y3;
                 W(4,:,set) = [0 0 0];
                 vertices = 0;
                 freeIndex = 4;
                 lambda = [l1 l2 l3];
                 W;
                 v=v';
                 break;
            end    
        end    
    end
      vertices = 2;
  end
  
    
end

if vertices==2;
    
    for i=1:length(I)
        if i==length(I)
            y1 = W(I(i) ,:,set);
            y2 = W(I(1) ,:,set);
            Is =[1 I(i)];
        else
            y1 = W(I(i)   ,:,set);
            y2 = W(I(i+1) ,:,set);
            Is = [I(i) I(i+1)];
        end
        hoi = 0;
        for p=1:length(I)
            if any( y1-W(p,:,set) )~=0 && any( y2-W(p,:,set)~=0 )  
                hoi=hoi + 1;
                IsComp(hoi) = p;
            end
        end
        A12= [1 (y2-y1)*y1'  
             1 (y2-y1)*y2' ]; 
%         A22= [(y1-y2)*y1' 1  
%              (y1-y2)*y2' 1 ];
        A22 = A12; 
    
        A12(1,:) = [1 0 ];
        A22(2,:) = [1 0 ]; 
 
        detA2(1) = det(A12);
        detA2(2) = det(A22);
        deltaA2 = detA2(1)+detA2(2);
        l1 = detA2(1)/deltaA2;
        l2 = detA2(2)/deltaA2;

        v = l1*y1 + l2*y2; 
        dist = norm(v);
                
        if l1>0 && l2>0         
            if (l1+l2)>0
                
                if any(IsComp)==1
                    delta=0;
                    k = min(Is);
                    deltaJ = false;
                
                
                    for j=1:length(IsComp)
                        for p=1:length(Is)
                            delta = delta + detA2(p) * ( (W(Is(p),:,set) * W(Is(1),:,set)') -( W(Is(p),:,set)*W(IsComp(j),:,set)' ) );
                        end
                        if delta<=0
                            deltaJ = true;
                        else
                            deltaJ = false;
                        end
                    end
                                
                    if deltaJ==true
                        W(1,:,set) = y1;
                        W(2,:,set) = y2;
                        W(3,:,set) = [0 0 0];
                        W(4,:,set) = [0 0 0];
                        vertices = 0;
                        freeIndex = 3;
                        lambda = [l1 l2];
                        W;
                        v = v';
                        break;
                    end
                else
                    W(1,:,set) = y1;
                    W(2,:,set) = y2;
                    W(3,:,set) = [0 0 0];
                    W(4,:,set) = [0 0 0];
                    vertices = 0;
                    freeIndex = 3;
                    lambda = [l1 l2];
                    W;
                    v = v';
                    break;            
                end       
            end        
        end
        vertices = 1;
    end
  
end

if vertices==1
    v = [0 0 0];
    for i=1:length(I)
        v = W(I(i),:,set);
        
        if i==1            
            vShortest = v;
        else 
            if norm(v)<norm(vPre) 
                vShortest = v;
            end
        end
       vPre = v; 
    end
    v = vShortest;
    dist =norm(v);
    freeIndex = 2;
    W(1,:,set) = v;
    W(2,:,set) = [0 0 0];
    W(3,:,set) = [0 0 0];
    W(4,:,set) = [0 0 0];
    l1=1;
    lambda = [l1];
    v = v';    
end


    

% figure(2)
% plot3([y12(1) y22(1) y32(1) y12(1)],[y12(2) y22(2) y32(2) y12(2)],[y12(3) y22(3) y32(3) y12(3)])
% fill3([y12(1) y22(1) y32(1) y12(1)],[y12(2) y22(2) y32(2) y12(2)],[y12(3) y22(3) y32(3) y12(3)],[0 1 0])
% hold on;
%axesm('mercator','MapLatlimit',[0 40],'MapLonLimit',[60 110]);
%[latc,lonc] = scircle2(0.0, 0.0 ,v(1), v(2)); 
%plot(latc,lonc,'r')
%axis([-10 10 -10 10 -10 10])
% grid on
% plot3(0,0,0,'o')
% [x,y,z] = ellipsoid(0,0,0,norm(v),norm(v),norm(v));
%surfl(x, y, z);
% plot3([0 v(1)],[0 v(2)], [0 v(3)]);
% hold off
% figure(6)
% hold on
% plot3([0 v(1)],[0 v(2)], [0 v(3)]);
% plot3( v(1),v(2), v(3), 'r x' );

%sphere(20)
