% calculating the support point

function  supPointATransformed = supportPoint(v, R, rRot,rTrans) %, Obs, obsRot, obsTrans);  
    
    %supPointA
    vecA = rRot'*v;
    
    etax = abs( R(1,1,1) ); etay = abs( R(1,2,1) ); etaz = abs( R(1,3,1) );
       
    if vecA(1)== 0
        vecA(1) = 1;
    end
    if vecA(2)== 0
        vecA(2)= 1;
    end
    if vecA(3)== 0
        vecA(3)= 1;
    end   
        
        supPointA = [ etax*sign(vecA(1)) etay*sign(vecA(2)) etaz*sign(vecA(3)) ]';
          
        supPointATransformed = rRot*supPointA + rTrans;
    
%      figure(5)
%      hold on 
%     %plot3([ 0 vecA(1) ],[0 vecA(2)], [0 vecA(3)] );
%     plot3([ rTrans(1) v(1)+rTrans(1) ],[rTrans(2) v(2)+rTrans(2)], [rTrans(3) v(3)+rTrans(3)] );
%      plot3(supPointATransformed(1),supPointATransformed(2), supPointATransformed(3),'k h' );
%     
   