

function [supPointTransformed] = supportPointCyl(v, radius,len, rRot,rTrans)

% rotating the vector
vec = rRot'*v;
% calculating the distance to the z-axis
sigma = (vec(1)^2 + vec(2)^2 )^0.5;

if vec(3) ==0
    vec(3) = 1;
end

if sigma >0
    supPoint = [radius/sigma*vec(1) radius/sigma*vec(2)  sign(vec(3))*len/2 ]';
else
    supPoint = [0 0 sign(vec(3))*len/2 ]';
end

% transfering the support point back to original position
    supPointTransformed = rRot*supPoint + rTrans;
    
%lengdeSupPoint = norm(supPointTransformed-rTrans);

%     figure(5)
%     hold on 
%     %plot3([ 0 vec(1) ],[0 vec(2)], [0 vec(3)] );
%     %plot3([ rTrans(1) v(1)+rTrans(1) ],[rTrans(2) v(2)+rTrans(2)], [rTrans(3) v(3)+rTrans(3)] );
%     plot3(supPointTransformed(1),supPointTransformed(2), supPointTransformed(3),'y h' );
    
   

