
function testDistances(step,w)

fig = 7;
colorOne = [1 0 0];
colorTwo = [0 1 0];


LinLimits = [ 0  80
              0 60
             -8-6.30   0-6.30] ;
% Specify the joint angle lmitis

JALimits = pi/180* [-180    180
                    -64-90  60-90
                    -101+45 34+45
                    -200    200
                    -120    120
                    -400    400];

for i =1:10

    [ManipD, ManD, fTD, lTD, lRotD, lTransD, DHD, linValuesD, thetaD] =...
        makeRandomRobotConfig();
    [linksN notInUse1] = size(ManipD);

    [linksN notInUse3] = size(ManipD);

    drawRobot(fig, colorOne, linksN, ManipD, lRotD, lTransD)

    config(2:4,1) = linValuesD;
    config(5:10,1) = thetaD;

    [newConfig jointAngles] = moveRandStep(step,w, config, LinLimits, JALimits);

    [Manip, Man, ffT, lfT, lfRot, lfTrans, DenHaf, LinLimits, JALimits] = makeRobot(newConfig(2:4,1), newConfig(5:10,1));

    drawRobot(fig, colorTwo, linksN, Manip, lfRot, lfTrans)

end
%  drawGantryCrane(fig, ffT, linValues(1))

axis([0 100 0 100 0 100]);
% hold off