
function [startNode, goalNode, Samples, theComp]= connectStartGoal(startCon, goalCon, Samples, Components, Obstacles, linksN, obsN, oRot, oTrans)

startConnected = false;
goalConnected = false;
len = length(Components);
startNode = length(Samples)+1;
goalNode = startNode + 1;
Config(1:10,1) = startCon;
Config2(1:10,1)= goalCon;
% makeAndDrawRobot(startCon(2:4), startCon(5:10), 1, [ 0 1 0])
% makeAndDrawRobot(goalCon(2:4), goalCon(5:10), 1, [ 0 0 1])

% % Getting the length of each component
% for i=1:len
%    compMat(i,1:2) = [length(Components(i).Node) i]; 
% end
% % Sorting the components, largest first
% compMat = sortrows(compMat); 
% Try connect to a component
for i = 1:len
    
    for j = 1:length(Components(i).Node ) 
        
        if Components(i).Node(j)==0
            disp('Empty component')
            break;
        end
        
%         for teller = 1:length(Components(i).Node) %Computing distance to all nodes in  one component
%             TempMat(teller,:) = [configDist(startCon, Samples(1:10, Components(i).Node(teller) ), [0 1 1 1 1 1 1 1 1 1] ), Components(i).Node(teller) ];
%         end
% 
%         % Sort the matrix with increasing distance
%         clear sortMat;
%         sortMat = sortrows(TempMat);

        tryCon = Samples(1:10,Components(i).Node(j)); % The configuration trying to connect to        
        % Try connect start configuration
        if ~startConnected
            Config(1:10,2) = tryCon;    
            if ~binCollisionCheckABB( Config,1, 5*pi/180,linksN, obsN, Obstacles, oRot, oTrans);
                Samples(1:10,startNode) = startCon;
                Samples(11,startNode) = i;
                startDist = configDist(startCon,tryCon, [0 1 1 1 1 1 1 1 1 1] );
                Components(i).NB(Components(i).Node(j), startNode ) = startDist;   %Adding the new distance
                Components(i).NB(startNode, Components(i).Node(j) ) = startDist;   %Adding the new distance
                Components(i).Node = [Components(i).Node; startNode ]; %Adding the new node
                
                makeAndDrawRobot(tryCon(2:4), tryCon(5:10), 1, [ 0 1 0])
                makeAndDrawRobot(tryCon(2:4), tryCon(5:10), 2, [ 0 1 0])
                startConnected = true;
            end
        end
        % Try connect goal configuration
        if ~goalConnected 
            Config2(1:10,2) = tryCon;             
            if ~binCollisionCheckABB( Config2,1, 5*pi/180,linksN, obsN, Obstacles, oRot, oTrans);   
                Samples(1:10,goalNode) = goalCon;
                Samples(11,goalNode) = i;
                goalDist = configDist(goalCon,tryCon, [0 1 1 1 1 1 1 1 1 1] );
                Components(i).NB(goalNode, Components(i).Node(j) ) = goalDist;  %Adding the new distance
                Components(i).NB(Components(i).Node(j), goalNode ) = goalDist;  %Adding the new distance
                Components(i).Node = [Components(i).Node; goalNode ]; %Adding the new node
                
                makeAndDrawRobot(tryCon(2:4), tryCon(5:10), 1, [ 0 0 1])
                makeAndDrawRobot(tryCon(2:4), tryCon(5:10), 2, [ 0 0 1])
                goalConnected = true;
            end            
        end
        
  
        
        if startConnected && goalConnected
            if Samples(11,startNode) == Samples(11, goalNode)
                theComp = Components(i);
                disp('Succsessfully connected start and goal configuration')
                return
            else
                error('Start and goal node not connected to same configuration')
               
            end
        end
    end
    
end

if ~startConnected && ~goalConnected
    error('Could not connect start and goal configuration')
elseif ~startConnected
    error('Could not connect start configuration')
elseif ~goalConnected
    error('Could not connect goal configuration')
end
        
        