
function makeAndDrawRobot(linValues, theta, fig, color)

LinLimits = [-20 20
             -20 20
             -5   0] ;
% Specify the joint angle lmitis

JALimits = pi/180* [-180    180
                    -100-90 110-90
                    -65      60
                    -180    180]; 

DenHaf = [  0              0     0.00  -pi/2
          -pi/2      linValues(2)     30.0  -pi/2
          -pi/2      linValues(1)     0.00  -pi/2
           pi/2      -1.20+linValues(3) 0.00   pi
           theta(1)       6.15   1.00  -pi/2
           theta(2)-pi/2  0.00   7.05   0
           theta(3)       0.00   1.35  -pi/2
           theta(4)       7.55   0.00   pi/2%]; 
           theta(5)       0.00   0.00  -pi/2
           theta(6)       0.85   0.00   0   ];
%thetaFinal = [DenHaf(1,1) DenHaf(2,1) DenHaf(3,1) DenHaf(4,1) ]'

Manip = 0.5*[ 0.10 0.10 0.10    
              2.00 2.00 40.0
              2.40 2.40 2.40
              1.50 1.50 8.00
              4.10 6.15 4.10 
              7.05 1.00 1.00
              2.00 2.00 3.60
              1.00 9.35 1.00
              0.00 0.00 0.00
              0.60 0.60 0.85];
          
Man = 0.5*[ 0.00 0.00 0.00
            0.00 0.00 0.00
            0.00 0.00 0.00
            0.00 0.00 8.00
            0.00 6.15 0.00
            7.05 0.00 0.00
            1.00 0.00 0.00 %3.60
            0.00 9.35 0.00  
            0.00 0.00 0.00
            0.00 0.00 0.85 ];         

  % Making transformation matrices for the final joint frames
[ffT, ffRot, ffTrans ] = dh(DenHaf);

  % Making transformation matrices for the final links
[lfT, lfRot, lfTrans ] = dhLinkABBSystem(ffT,Manip,Man);

[linksN notInUse1] = size(Manip);

drawRobot(fig,[color], linksN, Manip, lfRot, lfTrans)

% drawGantryCrane(fig, ffT, linValues(2))

axis([-20 20 -20 20 0 40]);
% hold off